VUZE CHANGELOG
-----------------

2008.07.01 | Vuze 3.1.1.0

FEATURE: Core | Added Auto Starting rule to seed large swarms first; useful when many overseeded torrents are in the queue or the upload capacity is far above average [The 8472]
FEATURE: UIv3 | Friend Chat (double click on friend icon to chat) [Gudy]
FEATURE: UIv3 | Friends Online Status
FEATURE: UIv3 | Ability to share content from your computer by dragging it to a Friend [Gudy]

CHANGE: Core  | Built-in plugins can now be disabled - it didn't work properly in earlier versions [amc1]
CHANGE: UI    | Create Vivaldi views for each DHT in use [Groundy]
CHANGE: UI    | Added support for rotation in Vivaldi view [Groundy]
CHANGE: UI    | Peers view hostname column now sorts host names by the most significant part first [The 8472] 
CHANGE: UIv3  | Finished fixes for the new styled dialog which are now default in Vuze/Vuze Advanced [knguyen]
CHANGE: UIv3  | Added friend icon next to activity entry [TuxPaper]
CHANGE: UIv3  | New plugin bar look (removed arrows, added selectable list all plugin bar views) [TuxPaper]

BUGFIX: Core  | Fixed bug which stopped downloads being stored in the chosen directory [amc1]
BUGFIX: Core  | Fixed bug which prevented torrent files from being moved properly [amc1]
BUGFIX: Core  | Reopening torrents does not delete files when setting some of the already existing files to DND anymore [The 8472]
BUGFIX: Core  | Fixed bug which prevented UPnP mappings from being successful when a SOCKS proxy was used [amc1]
BUGFIX: UI    | Fixed bug where delete icon on toolbar was not present on OSX [TuxPaper]
BUGFIX: UI    | Blank cells are now properly put at the bottom when sorting a table column [amc1]
BUGFIX: UIv3  | Fixed bottom of list views not repainting properly [TuxPaper]
BUGFIX: UIv3  | Remove type headers when switching to date sorting [TuxPaper]



2008.06.16 | Vuze 3.1.0.0

FEATURE: UI   | Protocol overhead is now shown in the speed graph [The 8472]
FEATURE: UI   | Downloads can now be moved and renamed while running - torrent will be auto-paused [amc1]
FEATURE: UI   | New "rename" action which renames torrent file, save file and displayed name at same time [amc1]
FEATURE: UI   | Plugin log views now support autoscrolling, pausing and regex filtering [The 8472]
FEATURE: UI   | Plugin menu items which in the right-click menu now appear in the "Torrent" menu also [amc1] 
FEATURE: UIv3 | Friends (sharing, bandwidth boost)
FEATURE: UIv3 | Greatly Improved Search
FEATURE: UIv3 | Experimental option to use Mozilla/Firefox as browser widget on any platform (XulRunner or Firefox 3 must be installed) [The 8472]
FEATURE: Plug | Added support for plugins to easily use an external configuration file for settings [amc1]
FEATURE: Plug | Plugins can now have full control over on-complete and on-removal file moving [amc1]
FEATURE: Plug | Added resource downloader to provide way to download files from Sourceforge [amc1]
FEATURE: Plug | Added API methods to generically pop up the message box to a user [amc1]
FEATURE: Plug | Added API methods to listen to download-complete events [amc1]
FEATURE: Plug | Added various convenience methods for using log views and config models [amc1]
FEATURE: Plug | Added API to allow native UI objects to be added to config views [amc1]
FEATURE: Plug | Added some more methods for plugins to control some transport mechanisms [amc1]
FEATURE: Plug | Added ability to add menus to status entry objects [amc1]
FEATURE: Plug | Plugins can now open files using default application handlers [amc1]

CHANGE: Core  | added "upload_only" flag to AZMP/LTEP handshakes, disconnect any uploading_only peers we don't need / that don't need us when disconnect seeds when seeding is set [The 8472]
CHANGE: Core  | Further startup speed improvements [The 8472, amc1, Parg]
CHANGE: Core  | Speedup of various file batch operations (priority changes) [amc1, The 8472]
CHANGE: Core  | Added option to allow the removal of files linked outside the save directory when removing data [amc1]
CHANGE: UI    | Column menu option to disable fast renaming in files view, changed fast rename to behave more like the windows explorer [The 8472]
CHANGE: UI    | In console UI, shrunk help text down to be more concise [amc1]
CHANGE: UIv3  | Removed Vuze Header (the top plugin bar is still there but you have to turn it on)

BUGFIX: Core  | Made change so that plugins could not inadvertently turn off Azureus extension protocol [amc1]
BUGFIX: Core  | The UDP tracker client option has been nonfunctional for quite a while now -> fixed [The 8472]
BUGFIX: Core  | Fixed various file-priority-change related bugs that resulted in error states [The 8472]



2008.04.10 | Azureus Vuze 3.0.5.2

FEATURE: UIv3 | Ability to rate directly from rating reminder activity entry [TuxPaper] 
FEATURE: UIv3 | Added progress spinner animation for the LightBox [knguyen]

CHANGE: Core  | Don't auto-UDP probe on initial announce if tracker not known to support UDP - hit on second and remember outcome [Parg]
CHANGE: Core  | Improve startup times by taking various torrent-load operations off main thread [Parg]
CHANGE: Core  | Add reason-messages for update check failures [Parg]
CHANGE: Core  | Use derived password to protect private key to allow us to persist password [Parg]
CHANGE: Core  | Get plugin update URL from version server to support potential future switch [Parg]
CHANGE: UI    | Run explicit tracker scrapes off UI thread to prevent blocking [Parg]
CHANGE: UI    | Allow UI initialisation to proceed before plugin init complete [Parg]
CHANGE: UIv3  | Always start on "Dashboard" tab (unless Advanced UI chosen), instead of sometimes starting on "On Vuze" tab [TuxPaper]
CHANGE: Plug  | Ensure that DHT republish events are scheduled using absolute time so recover correctly from computer suspend [Parg]

BUGFIX: Core  | Handle some badly formed torrents more gracefully (corrupt announce-lists) [Parg]
BUGFIX: Core  | Handle multiple SSL certs from same URL [Parg]
BUGFIX: Core  | URLDecode torrent filenames [Parg]
BUGFIX: Core  | Fix non-crypto fallback outgoing connections [Parg]
BUGFIX: Core  | Better (esp for Vista) detection of and setting of Azureus' .torrent file association [TuxPaper]
BUGFIX: UI    | Fix broken per-torrent upload speed setting via options tab [Parg]
BUGFIX: UI    | Fix alternating bg color not updating after changing in config [TuxPaper]
BUGFIX: UIv3  | Fix resource leaks related to light box (login window) [knguyen]



2008.03.05 | Azureus Vuze 3.0.5.0

FEATURE: Core | Added µTorrent PEX support [amc1]
FEATURE: Core | Azureus probes trackers for UDP-capabilities on first scrape/announce now and uses udp instead of http where available [The 8472]
FEATURE: Core | Added option to enforce IP bindings even when the specified interfaces are not available (useful when Azureus should not use certain network interfaces) [The 8472] 
FEATURE: Core | Intervene with http seeds if progressive stall imminent [Parg]
FEATURE: Core | Message user on startup if they have installed Azureus to read-only location [Parg]
FEATURE: Core | Added dnd status to XML stats [Parg]
FEATURE: UI   | Added option for "Open Containing Folder" menu action - which may integrate better with non-standard file browsers [amc1]
FEATURE: UI   | Added option for "Show Torrent Menu" -- Users can now decide to see the Torrent menu in the menubar or not [knguyen]
FEATURE: UI   | Fast Renaming (not moving) in the Files tab (click on name column) and Open Torrent dialog (click on dest. name column) [The 8472]
FEATURE: UI   | Completed downloaders column [The 8472]
FEATURE: UI   | Added start/stop to category menu [Parg]
FEATURE: UI   | Added per-category speed limits [Parg]
FEATURE: UI   | Added per-category option setting [Parg]
FEATURE: UI   | Added multiple-torrent options setting to MyTorrents view [Parg]
FEATURE: UIv3 | New menu configuration for Vuze and Vuze Advanced UI's [knguyen]
FEATURE: UIv3 | Activity Tab [TuxPaper]
FEATURE: UIv3 | Vuze Login from client [knguyen]
FEATURE: Plug | Added Network Status plugin to perform some basic network tests [Parg]
FEATURE: Plug | Allow plugins to specify their minimum JDK requirements [Parg]

CHANGE: Core  | Further memory footprint reductions; for additional tweaks see http://www.azureuswiki.com/index.php/Reduce_memory_usage [The 8472]
CHANGE: Core  | Reimplemented LT extension protocol code [amc1]
CHANGE: Core  | DND/Compact (aka Delete) priority now deletes all files that do not share pieces with normal/high priority files [The 8472]
CHANGE: Core  | Queuing rules now don't start any further torrents if the global up/download speed limits are reached [The 8472]
                 - makes "don't count torrent ..." minimum speed rules more useful to dynamically regulate the queue lengths
                 - recovers faster from chain reactions in case of connection loss
CHANGE: Core  | Made the crypto handshake a bit less predictable [The 8472]
CHANGE: Core  | Added support for IPv6 compact announces (client) and udp-multiscrapes (client+server) [The 8472]
CHANGE: Core  | Take note of more peer-source selections [Parg]
CHANGE: Plug  | Added support for plugins which implement mainline DHT [amc1]

BUGFIX: Core  | Request limiting/Priorities no longer pinch off LAN peers if seperate LAN speeds are enabled [The 8472]                 
BUGFIX: Core  | Increase time Azureus holds open listen socket on close to reduce dual-start window [Parg]
BUGFIX: Core  | Allow ~ character in tracker addresses to support I2P [Parg]
BUGFIX: Core  | Determine app name correctly on OSX so that restart works for renamed apps [Parg]
BUGFIX: UI    | Shells no longer use the low-res frog icon, the normal main window icon is now used instead [amc1]
BUGFIX: UI    | Limiting comments in General View to 5k characters under WinXP to avoid crashes due to faulty comctl32.dll [The 8472]
BUGFIX: UI    | Setting speed parameters manually now disables autospeed [The 8472]
BUGFIX: Plug  | Encode spaces correctly in get-right web seed urls [Parg]




2007.12.21 | Azureus Vuze 3.0.4.2

FEATURE: UI   | Added "Check Files Exist" menu option [amc1]
FEATURE: Plug | Perform low resource usage tracking of online torrents for swarm cross-population purposes [Parg]

CHANGE: Core  | Added option to disable download speed focus [The 8472]
CHANGE: Core  | Reduced memory usage for many-torrent instances [The 8472]
CHANGE: UI    | Multiple selected torrent export now works [amc1]

BUGFIX: Core  | Fixed IP filters not working when ALLOW instead of DENY was used [Parg]
BUGFIX: Core  | Improve rebuffering behaviour when real-time pieces are too slow for any peers to get in time [Parg]
BUGFIX: Core  | Ensure minimum buffer requirements are factored into ETA calculation [Parg]
BUGFIX: UI    | Eliminated various memory leaks [The 8472]



2007.12.06 | Azureus Vuze 3.0.4.0

FEATURE: Core | Reconnect to peers after unexpected disconnect / recover stats of recently disconnected peers [Parg,The 8472]
FEATURE: Core | Global download speed limit can also limit the number of outgoing requests, this should improve TCP performance [The 8472]
                 -does not work with auto-speed since an explicit download speed-limit must be set
                 -downloads from as few peers as possible when the global limit is reached 
                 -prioritizes downloads which are on the head of the queue
FEATURE: Core | IP binding now provides primitive round-robin load balancing for users with multiple internet connections; accepts interface names and IPv6 binding (if supported on the platform) [The 8472]
FEATURE: Core | Embed ChangeLog.txt in release jar [Nolar]
FEATURE: UI   | Column menu option to automatically put contents of cell into the tooltip [amc1] 
FEATURE: UI   | Piece distribution view is now also available as a peer subview [The 8472]
FEATURE: UI   | Added 'time remaining' column to peers view [Parg]
FEATURE: UI   | Added option to suppress file download dialog [knguyen]
FEATURE: UI   | Various progress reports have been unified; main status bar can display progress for certain processes now [knguyen]
FEATURE: Plug | Plugins can now change the color of rows [amc1]
FEATURE: Plug | Plugins can add configuration colour parameters [amc1]

CHANGE: Core  | Attempt to re-open a file when access fails to try and recover from a transient error [Parg]
CHANGE: Core  | Auto speed default is now the new 'beta' (v2) algorithm [ranul]
CHANGE: Core  | Revised piece picking code to deal better with some edge cases and snubbed peers [The 8472]
CHANGE: Core  | Share Ratio/min Seeds ignore rule now applies even when no tracker scrape is available [The 8472]
CHANGE: UI    | Added private torrent indicator to the general tab [The 8472]
CHANGE: UI    | Logging Consoles now have regex-based filters [The 8472]
CHANGE: UI    | Tweaked table views to use a bit less memory and run better when items are being quickly removed/added [TuxPaper]

BUGFIX: UI    | Don't hang UI redraw if file access is slow [Parg]
BUGFIX: UI    | Fixed inconsistencies in the Torrent Open Dialog related to renaming and retargeting files and directories [The 8472]  



2007.10.04 | Azureus 3.0.3.4

FEATURE: UI   | Added "All Peers" view [amc1]

CHANGE: Core  | Added workarounds for some buggy UPnP router implementations [parg]
CHANGE: UI    | NAT status bar indicator and health icons now ignore UDP and LAN-local connections [The 8472]

BUGFIX: Core  | Fixed bug where a torrent's save location is "forgotten" when a recheck is done in some circumstances [amc1]
BUGFIX: UI    | times > 365 days (such as the uptime) are now displayed properly [The 8472]



2007.09.21 | Azureus 3.0.3.2

BUGFIX: Core  | Fixed MacOSX playback bug [TuxPaper]
BUGFIX: Core  | Fixed update restart bug [Parg]



2007.09.20 | Azureus 3.0.3.0

FEATURE: Core | Added experimental support for LibTorrent extension protocol handshake [amc1]
FEATURE: Core | Providing some experimental options for possible workarounds for a particular traffic shaping method
                 See http://www.azureuswiki.com/index.php/Avoid_traffic_shaping#Level_5 for further details 
FEATURE: UI   | Added available disk space indicators to the torrent open dialog (requires Java 1.6) [The 8472]
FEATURE: UI   | Added "handshake reserved bytes" column in peer view [amc1]
FEATURE: UI   | Added "Open Transfer Bar on start" and "Remember Transfer Bar" location options [amc1]
FEATURE: UI   | Added http-seed config to torrent creation wizard [Parg]
FEATURE: UIv3 | Embedded Media Player [TuxPaper] 

CHANGE: Core  | Speedup hash-checking by ~30% / less CPU usage [The 8472]
CHANGE: Core  | More improvements to client identification code [amc1]
CHANGE: UI    | Provide both "per-torrent" and "across-torrents" speed menu options [amc1]
CHANGE: UI    | Speed improvements for menu generation and changing file priority in "Files" view [amc1]
CHANGE: UI    | Allow minibars to stick to any screen border in multi monitor setups [The 8472]
CHANGE: Plug  | Plugins can now dynamically register language resource bundles [amc1]

BUGFIX: Core  | Fixed bug when trying to add torrents with semi-colon characters in filename [amc1]
BUGFIX: Core  | LAN peer detection for explicit IP addresses was broken [Parg]



2007.08.29 | Azureus 3.0.2.2

CHANGE: UI    | Improved usability of speed scale widget. [TuxPaper]
CHANGE: UI    | Restored reposition functionality of torrent context menus [TuxPaper]

BUGFIX: Core  | *nix: Allowing multi-instance now works again [TuxPaper]
BUGFIX: Core  | IPv6 DHT v4 pollution fix [Parg]
BUGFIX: UI    | MacOSX: Fixed not remembering user turned off Maximized state [TuxPaper]
BUGFIX: UI    | MacOSX: Fixed Drag and Drop for moving torrents in My Torrents view [TuxPaper]
BUGFIX: UI    | A few config pages had their labels missing [TuxPaper]



2007.08.16 | Azureus 3.0.2.0

FEATURE: Core | Act on suspend/resume events on Windows [Parg]
FEATURE: Core | Added new AZ message to inform of bad pieces [Parg]
FEATURE: Core | Added new stacked HAVE message to reduce peer-peer overhead [Parg]
FEATURE: Core | IPv6 support - dht, version server, tracker and improved transport [Parg]
FEATURE: UI   | New "Torrent" menu in the menu bar [amc1]
FEATURE: UI   | New "Piece Distribution" subview in the pieces tab [The 8472]
FEATURE: UI   | Auto-speed ping views in Tools->Statistics->Transfers when Auto Speed is enabled [Parg]
FEATURE: UI   | "Clear Resume Data" menu option added [amc1]
FEATURE: UI   | "Clear remembered save paths" option added (for the Open Torrent dialog) [amc1]

CHANGE: Core  | Optimise memory usage for single-file downloads [Parg]
CHANGE: Core  | Optimise memory usage for queued torrents (no need to keep resume data in memory) [Parg]
CHANGE: Core  | Much better peer ID identification code added, many more clients now correctly identified [amc1]
CHANGE: Core  | Changes made to identify some "fake" clients (or other clients which identify themselves in a problematic way) [amc1]
CHANGE: Core  | Biased optimistic disconnect slightly against leechy peers [The 8472]
CHANGE: Core  | Core changes in some places to allow "Default save path" to be used without requiring "Use default data dir" to be enabled [hasturkun]
CHANGE: Core  | Reduce CPU usage when many (queued) torrents are present and in the the pieces view [The 8472]
CHANGE: Core  | *nix: New startup script to detect Gecko/XULRunner and to allow better restarting [TuxPaper]
CHANGE: UI    | UL/DL speed selection on right click of status bar changed from menu to scale widget. [TuxPaper]
                Usage: (1) MouseDown+Drag+MouseUp  (2) Click+Move+Click  (3) Click+type number+Enter
CHANGE: UI    | Open Torrent Window now asks to create directories if they don't exist yet, instead of evilly auto-creating them when you click the Browse button [The 8472] 
CHANGE: UI    | Added download status, distributed copies and completed piece count to the General torrent view [amc1, The 8472]
CHANGE: UI    | User Comment field more useful in General torrent view - easy edit link, hyperlink formatting, auto-resizing [amc1]
CHANGE: UI    | "Show Transfer Bar" menu option is now a checkbox menu item - so you can now hide the transfer bar using the menu item [amc1]
CHANGE: Plug  | Added setVisible method for plugin menu items [amc1]
             
BUGFIX: Core  | Fixed bug where renaming a download for a single file torrent would sometimes cause data to get out of sync and cause file errors [amc1]
BUGFIX: Core  | Allow pipelined http seed requests to switch torrents [Parg]
BUGFIX: Core  | Bootstrap DHT better when no contacts [Parg]
BUGFIX: Core  | Fixed bug where renaming a download in some conditions would generate "Target is sub-directory" errors [amc1]                
BUGFIX: UI    | Fixed swarm view rendering bug where some incomplete peers were shown as full circles [The 8472]
BUGFIX: Plug  | Fixed bug where previously removed child menu items would still be present when generating some menus [amc1]



2007.06.20 | Azureus 3.0.1.6

FEATURE: Core | IP Filter Autoloading. Supports DAT (eMule), P2P (PeerGardian, splist), and P2B v1,2,3 (Peer Gardian 2) formats. [TuxPaper]
FEATURE: UI   | Option to display divider lines every 60 updates on the Statistics view [amc1]
FEATURE: Plug | Added helper class to make listening to download events across all downloads easier [amc1]
FEATURE: Core | Azureus AutoSpeed v2 Beta [ranul]

BUGFIX: Core | Plugin installation/updates using Vista [parg,tuxpaper]



2007.05.24 | Azureus 3.0.1.4

FEATURE: Core | Byte-level download control for Downloads [Parg] 
FEATURE: Core | Speed tester wizard [ranul,Parg]
FEATURE: UI   | Added "Transfers Bar" (similar to the "Download Bar") [amc1]
FEATURE: UI   | Correctly identifies FoxTorrent and Blizzard Downloader peers [amc1]
FEATURE: UI   | Determines version information for Bits On Wheels and Opera peers [amc1]
FEATURE: UI   | Vivaldi view can use mouse wheel too zoom now (requires clicking on the view first) [TuxPaper]
FEATURE: UI   | Date Completed column [TuxPaper]
FEATURE: UI   | (Beta) Various Auto Speed algorithms [ranul]
FEATURE: UI   | Auto-open MyShares if any shares [Parg]

CHANGE: Core  | Handle 503s better with webseeds [Jochen Seifarth,Parg]
CHANGE: Core  | Disable HTTP authentication dialog for webseeds [Parg]
CHANGE: Core  | Reduce DHT registration counts for queued torrents [Parg]
CHANGE: UI    | Running Azureus while azureus is already running now brings Azureus to front [TuxPaper]
CHANGE: UI    | OSX: Make minimize to status bar icon hide the main window instead of putting it in the doc [TuxPaper]

BUGFIX: Core  | Updater now works on Vista with security challenged users [TuxPaper] 
BUGFIX: Core  | Fixup "Get Right" webseed handling as per the spec [Jochen Seifarth]
BUGFIX: Core  | Fixed bug which sometimes prevented corrupted torrents being removed properly [amc1]
BUGFIX: Core  | Fix rare case where app dir on win32 could report wrong azureus dir on multi-az computers [TuxPaper]
BUGFIX: Core  | Prevent upnp dispatcher queue from growing too large [Parg]
BUGFIX: Core  | Limit UPnP write-request exec threads [Parg]
BUGFIX: UI    | Fixed force starting a torrent via the Open Torrent Window options. [TuxPaper]



2007.04.12 | Azureus 3.0.1.2

FEATURE: Core | Auto-speed: added control for forced-max network speed [Parg]

BUGFIX: Core  | 100% CPU problem in network code under some conditions [Parg]



2007.04.05 | Azureus 3.0.1.0

FEATURE: Core | Option to clear stored tracker list used for creating torrents [amc1]
FEATURE: UI   | Option to add full UPnP debug information to the log view [amc1]

BUGFIX:  UI   | Fixed issue where excessive file checks were being done when generating the torrent context menu [amc1]


2007.03.15 | Azureus 3.0.0.8

FEATURE: Core | Alerts can now be shown in individual message popup boxes [amc1]
FEATURE: Core | Alerts can now be suppressed and shown on demand [amc1]
FEATURE: Core | Per-peer upload/download speed limits [Parg]
FEATURE: Core | Per-category upload/download speed limits [Parg]
FEATURE: Core | Per-torrent super-seeding via MyTorrents context menu [Parg]
FEATURE: UI   | Option to auto-download and install updates [TuxPaper]
FEATURE: UI   | Overall piece map for Piece View [TuxPaper]
FEATURE: UI   | New "Peer ID" columns in the Peers View [amc1]
FEATURE: Plug | Plugins can now add their own status indicators on the status bar [amc1]
FEATURE: Plug | Plugins can now add menu items to the system tray, download bars, menu bar [amc1]
FEATURE: Plug | Plugins can now remove menu items that are created (allows for dynamic menus) [amc1]
FEATURE: Plug | Added extra methods on DownloadManager making it easier to listen to download events [amc1]

CHANGE: Core  | Include msvcr71.dll in Windows installation bundles, for compatibility with Java6 [Nolar]
CHANGE: Plug  | Added full set of config parameter methods for completeness [amc1]

BUGFIX: Plug  | UPnP plugin now correctly attempts to remove existing mappings if they are in the way of new mappings [amc1]
BUGFIX: Core  | Fix Re-adding a torrent causing "1-" or "-1" directories or files [TuxPaper]
BUGFIX: Core  | Fixed bug where files were sometimes moved into a subdirectory, where the directory name was only one character long [amc1]
BUGFIX: Plug  | Fixed bug where some plugin menu items didn't appear under certain conditions [amc1]


2007.01.22 | Azureus 2.5.0.4 / 3.0.0.6

FEATURE: Core | New users default save directory is now located in their "My Documents" directory, under "Azureus Downloads" [TuxPaper]
FEATURE: Core | Show alerts raised during closedown on next start as these often don't get displayed due to UI shutdown [Parg]
FEATURE: Core | Allow plugin installs to place jars into the plugin-shared "shared/lib" directory [Parg]
FEATURE: Plug | Unsafe config read/writing [parg]
FEATURE: Plug | Plugins can now open and close download bars [amc1]

CHANGE: Core  | Added scrape delay for stopped/errored torrents, and torrents with high share ratios [TuxPaper]
CHANGE: Core  | Allow only one active scrape for each tracker [TuxPaper]
CHANGE: Core  | Release piece-map when not required [Parg]
CHANGE: Core  | ASN lookup via DNS queries only [Parg]
CHANGE: Core  | Full recheck of torrent when part of torrent fails hash check on completion [TuxPaper]
CHANGE: Core  | Take note of banned IPs when we have IP filter turned off - these are independent [Parg]
CHANGE: Core  | Disable download peer caching for private torrents [Parg]
CHANGE: Core  | Disconnect currently connected peers on tracker URL change for private torrents [Parg]
CHANGE: Core  | Remove unused download/upload specific stats from version-check message [Parg]
CHANGE: Core  | Include IP override in NAT check message for NAT check server to use [Parg]
CHANGE: Plug  | Timeout UPnP port releases during closedown to prevent Azureus hanging [Parg]

BUGFIX: Core  | Fix choke/unchoke cycle bug for lan local peers [Nolar]
BUGFIX: Core  | Fix auto moving torrent data with DND files [TuxPaper]
BUGFIX: Core  | Fix NPE causing XML stats not to be written [Parg]
BUGFIX: UI    | Fix crash when opening non-torrent URL when OS has no recognized HTML viewer [TuxPaper]
BUGFIX: UI    | Fix big icon in name column for OSes using GTK [TuxPaper]
BUGFIX: UI    | Make Download Basket work again for drag and dropping [TuxPaper]




2007.01.10 | Azureus 2.5.0.2

FEATURE: Core | Added method to XFS specific allocation of new files [Greg]
FEATURE: Core | Added per-torrent max seeds parameter [Parg]
FEATURE: Core | Added per-torrent max peers parameter [Parg]
FEATURE: UI   | Total file size added to Open Torrent Window [TuxPaper]
FEATURE: UI   | Option to show complete downloads with incomplete "do not download" files in the download area [TuxPaper]
FEATURE: UI   | Added custom user comment field [amc1]
FEATURE: UI   | Added file extension column in files view [amc1]
FEATURE: UI   | Spinners for config field that take numbers [TuxPaper]
FEATURE: UI   | Setting for Minimum # of Simultaneous Active Downloads to have running at any given time [TuxPaper]
FEATURE: UI   | Console UI NAT test [Parg]
FEATURE: UI   | Option to have separate rename and retarget menu items in Files view [amc1]
FEATURE: Plug | Plugins can now create submenus. [amc1]
FEATURE: Plug | Added code to allow plugins to get text input from a user in non-UI specific way. [amc1]
FEATURE: Plug | Plugins now have better support to organise file data within default save directories. [amc1]
FEATURE: Plug | Plugins can now easily add hyperlinks to config sections. [amc1]

CHANGE: Core  | Improve the "presence" handling for torrents created by ourselves [Parg]
CHANGE: Core  | Less memory footprint [Parg,TuxPaper]
CHANGE: Core  | Faster startup for large torrent lists (and no naughty plugins) [Parg]
CHANGE: Core  | NAT test moved to separate server
CHANGE: Core  | Download up/down idle counts now persisted over restart [Parg]
CHANGE: UI    | Open torrent windows now always has OK button enabled with warning message if pressed when in invalid state [TuxPaper]
CHANGE: UI    | Remove nag/donation window [TuxPaper]
CHANGE: UI    | Differentiate between libTorrent (Rakshasa) and libtorrent (Rasterbar) [TuxPaper]
CHANGE: UI    | For multi-file torrents, icon in name column displays icon for largest file (+ a little folder icon) [TuxPaper]
CHANGE: UI    | Faster filtering when torrent list is large [TuxPaper]
CHANGE: UI    | Better logic when preventing a user deselecting files to download from Open Torrent window [amc1]

BUGFIX: Core  | If clipboard has just a " or "" in it the open-torrents dialog won't open [Parg]
BUGFIX: Core  | Setting of UDP port not working [Parg]
BUGFIX: Core  | Less flipping of downloads from queued <--> downloading during the time a FP seed is forced active [TuxPaper]
BUGFIX: Core  | Fix memory leak causing slow, but eventual OOM and slow down of Azureus [Parg]
BUGFIX: Core  | OSX: Handle volume not mounted on startup by erroring instead of creating a directory in /Volumes [TuxPaper]
BUGFIX: Core  | Fix to stop already complete downloads being moved by "move-on-completion" rules [amc1]
BUGFIX: UI    | Fix (some) painting issues in pieces+files view [TuxPaper]
BUGFIX: UI    | Fix to allow negative values for Multi-monitor window positions [TuxPaper]
BUGFIX: UI    | Fixed memory leak in "Mr Slidey" code [amc1]
BUGFIX: UI    | Fix UI loss when clicking delete from icon bar while in Details view [TuxPaper]
BUGFIX: Plug  | Fixed bug where some listeners for table columns were not registered properly. [amc1]




2006.08.21 | Azureus 2.5.0.0

FEATURE: Core | Reduced CPU usage, especially in some unusual conditions [MjrTom]
FEATURE: Core | Explicit local subnet and peer injection option for Lan Peer Finder [Parg]
FEATURE: Core | Auto upload speed [Parg]
FEATURE: Core | DND completion handled better [Parg,TuxPaper]
FEATURE: Core | Added option for per-torrent max upload speed when upload busy [Parg]
FEATURE: Core | Ranges allowed for port listing to ignore peers from. [TuxPaper]
FEATURE: Core | Added option to move completed download on removal [amc1]
FEATURE: Core | Signed updates for increased security [Parg]
FEATURE: Core | UDP fallback on connection fail [Parg]
FEATURE: Core | Support for initial crypto tracker spec [Parg]
FEATURE: Core | Faster queued torrent startup [Parg]
FEATURE: Core | Option to disable tracker support for full-scrape [Parg]
FEATURE: Core | Added ability to rename the directory save name for a multi-file torrent [amc1]

FEATURE: UI   | File pieces shown in files view [Parg]
FEATURE: UI   | Ability to best guess folder you want to save torrent data to based on existing torrents [TuxPaper]
FEATURE: UI   | Filter for Config Options [TuxPaper]
FEATURE: UI   | "Help -> Generate Debug Info" to help us solve bugs [TuxPaper]
FEATURE: UI   | Ability to customise the speed intervals for download / upload speed menus [amc1]
FEATURE: UI   | Ability to rename the displayed title of a download [amc1]
FEATURE: UI   | "date added", "idle up", "idle down", "req in", "req out" colmns added to MyTorrents [Parg]
FEATURE: UI   | manual file recheck order [Parg]
FEATURE: UI   | Option to remember passwords [Parg]
FEATURE: UI   | OSX: Open .torrent files into Azureus via Finder/Desktop/etc [TuxPaper]
FEATURE: UI   | Option to send popup message when download of a torrent (or individual file) has completed [amc1]
FEATURE: UI   | Ability to change behaviour of popups: auto-hide behaviour and adding timestamp to messages [amc1]
FEATURE: UI   | Torrent-info panel added to show MyTorrent's column attributes in a single place. Torrent encoding moved from General tab to here [Parg]
FEATURE: UI   | Progress warning to user when long file operations in progress that would otherwise hang the UI [Parg]

FEATURE: Plug | Simple NAT-PMP implementation [Marc Colosimo]


CHANGE: Core  | Reduced starting many pieces instead of completing current ones [MjrTom]
CHANGE: Core  | Further modifications to optimistic disconnect algorithm [MjrTom]
CHANGE: Core  | Longer scrape delays: [TuxPaper]
                 - 1 hr min for torrents in stopped state
                 - 2 hrs min for torrents in error state
                 - 3 hrs min when tracker sends no torrent info (no hash error)
                 - As per usual, flags->min_request_interval will override next scrape time
CHANGE: Core  | Asynchronous existing torrent loading at startup (makes startup feel faster) [TuxPaper]
CHANGE: Core  | Disk read cache disabled by default [Parg]
CHANGE: Core  | Better detection of unix OSes (Linux, FreeBSD, Solaris, etc) and custom ports that do not conform to our install structure [TuxPaper,Parg]

CHANGE: UI    | More time periods in folder-rescan list [Parg]
CHANGE: UI    | Option to hide toolbar [TuxPaper]
CHANGE: UI    | Option to disable program icon for name column (may speed up OSX users) [TuxPaper]

CHANGE: Plug  | Use UPnP to read external IP address if possible [Parg]


BUGFIX: Core  | Fix for pieces not completing due to too many snubbed peers [MjrTom]
BUGFIX: Core  | Better handling of invalid peer/seed count from tracker [TuxPaper]
BUGFIX: Core  | ed2k hash wrong on block boundaries [Parg]
BUGFIX: Core  | upload slot default now applied correctly (was fixed at torrent add time) [Parg]
BUGFIX: Core  | Various seeding rules fixes, mostly related to Seed:Peer ratio, 1st Priority, or 'None' ranking mode [TuxPaper]

BUGFIX: UI    | speed graphics failing on high speeds [Parg]
BUGFIX: UI    | Per-torrent options view now synced with global defaults and has "reset" button [Parg]
BUGFIX: UI    | Slide-in alert message not closeable (GTK+ users) [TuxPaper]




2006.03.16 | Azureus 2.4.0.2

FEATURE: Core | Make default recheck behaviour after crash only check pieces active at last save point plus config to revert to old behaviour of checking everything [Parg]
FEATURE: Core | Attempt to repair invalid port #s returned from trackers potentially improving outgoing connection success rate [MjrTom]
FEATURE: UI   | Allow some selection of split data/protocol stats in some views [Parg]

CHANGE: Core  | Improved payload data vs. protocol overhead byte accounting [Nolar]
CHANGE: Core  | Remove option to truncate files when setting to do-not-download as too many users confused by this [Parg]
CHANGE: Core  | Pick up alerts raised during closedown and give user chance to see them [Parg]
CHANGE: Core  | Improved optimistic disconnect algorithm in several ways - should speed up single seed torrents [MjrTom]
CHANGE: Core  | Only remove temp files created by Azureus in the "tmp" dir as some users placing files in there [Parg]
CHANGE: Core  | Resumed downloads now placed into queued state rather than started [Parg]
CHANGE: Core  | Improved magnet download potential [Parg]
CHANGE: Plug  | Added vendor id to DHT packets and increased version appropriately [Parg]
CHANGE: Plug  | Warn if UPnP port removal is slow as this can hang AZ closedown [Parg]
CHANGE: UI    | Add NAT Test item to OSX "Azureus" menu [Nolar]
CHANGE: UI    | Filter-as-you-type is now more visible [TuxPaper]
CHANGE: UI    | "Show In Explorer" on a Folder now opens to show what's in the folder [TuxPaper]
CHANGE: UI    | Mr. Slidey formats URLs to clickable links [TuxPaper]
CHANGE: UI    | Language Selection on first visible screen after initial installation [TuxPaper]
CHANGE: UI    | Reduced the # of windows popping up at once on first run after installation [TuxPaper]

BUGFIX: Core  | Ensure SO_REUSEADDR is set when binding during NAT test [Nolar]
BUGFIX: Core  | Retain data from terribly slow senders [MjrTom]
BUGFIX: Core  | Fixed a case of potentially becoming uninterested in peers incorrectly [MjrTom]
BUGFIX: Core  | Prevent infinite recursion and breakage of some file systems when moving torrent's data into a folder inside itself [Parg]
BUGFIX: Core  | Improve fingerprint performance of shares [Parg]
BUGFIX: Core  | Prevent reporting of double completion events to tracker under some circumstances [Parg]
BUGFIX: Core  | Ensure DNS timeouts are set as early as possible as they weren't working [Parg]
BUGFIX: Core  | Change per-torrent max peers so that values shown correctly in UI and also allow unlimited override [Parg]
BUGFIX: Core  | Fix bug in crypto stream that could lead to corruption [Parg]
BUGFIX: Core  | Strip unwanted attributes from imported torrents such as "file name" [Parg]
BUGFIX: Core  | Ignore invalid Vivaldi coords that are too small [Parg]
BUGFIX: Core  | Default to trivial url in torrent if it is missing [Parg]
BUGFIX: Core  | Fix initialisation sequence problem that was causing startup errors if config corrupt [Parg]
BUGFIX: Core  | Apply correct permissions when updated to Windows prog dir to fix multi-user problems on update [Parg]
BUGFIX: Core  | Downloads stopped during seeding recheck sometimes came back as 99.x% complete [Parg]
BUGFIX: Core  | Fix up timers on clock change to ensure announce and scrape work ok (amongst others) [Parg]
BUGFIX: Plug  | Column dispose listener wasn't being called when there was no cell dispose listener [TuxPaper]
BUGFIX: UI    | Fixed window size/position not always being saved [TuxPaper]
BUGFIX: UI    | Fix default language: Use same language from diff. country when user's lang/country doesn't exist [TuxPaper]
BUGFIX: UI    | Fixed new table rows getting last graphic cell's image [TuxPaper]
BUGFIX: UI    | Column sort is now case-insensitive (again) for text columns [TuxPaper]
BUGFIX: UI    | Fix number display Seeds2Peer column (when radio is really small) [TuxPaper]
BUGFIX: UI    | Fixed Drag and Drop.  Should work in Windows and Linux. [TuxPaper]
BUGFIX: UI    | Mr. Slidey no longer slides from (on slide-in) or onto (on slide-out) a different monitor [TuxPaper]




2006.02.11 | Azureus 2.4.0.0

FEATURE: Core | Logging seperated into sections [TuxPaper]
FEATURE: Core | Plugins can be disabled from starting up [TuxPaper]
FEATURE: Core | Separate high-speed transfer rates between peers within the local LAN [Parg,Nolar]
FEATURE: Core | Encrypted peer connections [Parg,Nolar]
FEATURE: Core | Revamped and much improved piece-picking code [MjrTom]
FEATURE: Core | Option to bind outgoing connections to the same local port, may help with NAT router instability [Nolar]
FEATURE: Plug | HTTP webseed support (http://www.getright.com/seedtorrent.html) [Parg]
FEATURE: Plug | New "team seeder" plugin [Parg]
FEATURE: Dev  | Plugins can now add views/tabs to Torrent Details, Peers View, etc [TuxPaper]
FEATURE: UI   | Draggable column reordering and column indicator (w/SWT 3.2+) [TuxPaper]
FEATURE: UI   | Peer piece map in Peers Tab [TuxPaper]
FEATURE: UI   | Manual tracker scrape option if auto-scrape disabled [Parg]
FEATURE: UI   | Share-ratio indicator and options to hide the various indicators [Parg]
FEATURE: UI   | Separate per-torrent options panel [Parg]

CHANGE: Core  | Clearer firewalled/NAT status reporting [Nolar]
CHANGE: Core  | Do not open the wiki NAT problem page if firewall status is OK [Nolar]
CHANGE: Core  | Disk manager threads - limited pool now serves all disk read/write requests [Parg]
CHANGE: Core  | Single thread now serves torrent piece picking etc (was one per download) [Parg]
CHANGE: Core  | Persistent IP bans now have limited lifetime [Parg]
CHANGE: Core  | Reworked compact storage type to support migration of formats [Parg]
CHANGE: Core  | Less requirements to pause downloads when changing file priorities [Parg]
CHANGE: Core  | Only one torrent can now be checking at a time [Parg]
CHANGE: Core  | DHT size estimation improved [Parg]
CHANGE: Core  | Default listen port number now randomized for new installs [Nolar]
CHANGE: Core  | Interrupted "seeding+checking" files now rechecked on startup [Parg]
ChANGE: Core  | Under unix, use all-lowercase ~/.azureus/ as the config dir [Nolar]
CHANGE: UI    | Seeding+checking completeness now shown in status [Parg]
CHANGE: UI    | Faster filling of tables (Mac/some Linux) [TuxPaper]
CHANGE: UI    | Opening torrents changed to use one opener dialog (w/options to change destination filenames, disable files, etc) [TuxPaper]
CHANGE: UI    | Find-As-You-Type in 'My Torrents' changed to Filter-As-You-Type.  Ctrl-BS to clear filter. [TuxPaper]

BUGFIX: Core  | Fix transfer stall bug when MTU size is greater than max upload/download rate [Nolar]
BUGFIX: Core  | Improved peer connection counting [Parg]
BUGFIX: Core  | Tracker wasn't handling "accept-encoding" properly [Parg]
BUGFIX: Core  | Multiple file renames/retargets wasn't working [Parg]
BUGFIX: Core  | Synchronous scrape wasn't working [Parg]
BUGFIX: Core  | Fixed move-on-complete bug when target was a link [Parg]
BUGFIX: Core  | Fixed DND/Delete vs piece needed/interested in peer issues [MjrTom]
BUGFIX: Core  | Properly catch Windows shutdown/logoff events [Parg]
BUGFIX: UI    | Selection moves properly with CTRL+<UP,DOWN,HOME,END> and sorting [TuxPaper]
BUGFIX: UI    | URL Drag'nDrop Improvements - Unicode, IE Links (Windows) [TuxPaper]




2005.11.22 | Azureus 2.3.0.6

FEATURE: Core | Built in tracker support for multiple listen ports [Parg]
FEATURE: Core | Tracker support for multi-hash scrapes [Parg]
FEATURE: Core | "Date added" field added for hosted torrents [Parg]
FEATURE: Core | Alternate max upload rate limit when only seeding option [Nolar]
FEATURE: Core | Ability to move a download's data files and torrent added [Parg]
FEATURE: Core | Added ability to turn off DHT originated IP Filter violation logs [Parg]
FEATURE: Core | When a peer is banned remove any data downloaded from it in partially complete pieces [Parg]
FEATURE: Core | Added "block banning" feature when multiple bad peers found with "close" IPs [Parg]
FEATURE: Core | Support for platform-specific plugin update components [Parg]
FEATURE: Core | Support for .torrent file download using just infohash hex string (via DHT magnet lookup mechanism) [Nolar]
FEATURE: Core | Added some control over initial share ratio for "add for seeding" downloads [Parg]
FEATURE: Core | Added feature to allow disabling of multi-hash tracker scrapes [Parg]
FEATURE: Core | Tracker connections respect bind-ip settings (http only) [Parg]
FEATURE: Core | Banned ips persisted across restart [Parg]
FEATURE: Core | Ability to add an alternative max-torrent-limit when seeding [Parg]
FEATURE: Core | DHT NAT punching for firewalled peers [Parg]
FEATURE: Core | Ability to rename and redirect files within a torrent [Parg]
FEATURE: Core | Compact storage for "do not download" files [Parg]
FEATURE: Core | Magnet URI protocol registration under windows [Parg]
FEATURE: Plug | UPnP plugin will warn if it discovers a router that has known protocol problems [Parg]
FEATURE: Plug | Magnet URI accessor method added to Torrent [Parg]
FEATURE: Plug | Added "launchable plugins" that can be used to start Azureus [Parg]
FEATURE: Plug | Added single-instance management function [Parg]
FEATURE: Plug | Made some platform-specific functions available to plugins [Parg]
FEATURE: Plug | Ability to add Swing based interfaces as plugin views [Parg]
FEATURE: UI   | Console UI support for viewing specific plugin logs [Parg]
FEATURE: UI   | Beginner configuration user mode provides a simplified interface [Gouss]
FEATURE: UI   | Support for --closedown parameter to org.gudy.azureus2.ui.swt.Main to closedown an existing AZ instance [Parg]
FEATURE: UI   | Added Average Peer Completion percentage column to MyTorrents view and Details view [Nolar]
FEATURE: UI   | Added NAT status icon to status area [Parg]
FEATURE: UI   | Indicate potential DHT port problems in SWT status area [Parg]
FEATURE: UI   | Added swarm average to activity view plus a legend [Parg]
FEATURE: UI   | Console support for listing shares improved, deleting of shares added [Parg]

CHANGE: Core  | Countermeasures against swarm DOS/poisoning [Nolar]
CHANGE: Core  | Health status for swarms where all known peers are connected now reported as OK [Parg]
CHANGE: Core  | Friendly hash-checking option now only applied during recheck operations and delay based on piece size [Parg]
CHANGE: Core  | Don't automatically remove directory contents shares if they (appear to) have been deleted [Parg]
CHANGE: Core  | Improved algorithm for detecting DHT port reachability [Parg]
CHANGE: Core  | DHT - removed cache-distance metrics and added value versions to handle value evolution correctly [Parg]
CHANGE: Core  | Reduced thread count by aggregating async listener dispatchers [Parg]
CHANGE: Core  | Major refactoring of Download and Disk managers [Parg]
CHANGE: Core  | Download totals don't include hash fails and discards and aren't included in share-ratio calculation [Parg]
CHANGE: Core  | "Max simultaneous outbound connection attempts" option no longer accepts zero as a disable value [Nolar]
CHANGE: Core  | Under OSX, new bundle launches using the Java Preferences application configured JVM, enabling JRE 5.0 support [Nolar]
CHANGE: Core  | Under Windows, now runs via a launcher built by exe4j - taskmanager process is now "Azureus.exe" [Nolar,Parg]
CHANGE: Plug  | Major refactoring of plugin interface to separate out UI-level and core-level stuff [Parg]
CHANGE: UI    | Update to the latest release SWT library (3.1.1) [Nolar]

BUGFIX: Core  | Fix interested flag being set sometimes when seeding [Nolar]
BUGFIX: Core  | Wrong file name returned for stopped simple torrents [Parg]
BUGFIX: Core  | Seeder/leecher counts missing for published torrents [Parg]
BUGFIX: Core  | Stats going negative for hosted torrent average up/down [Parg]
BUGFIX: Core  | Fix piece request ignore bug [Nolar]
BUGFIX: Core  | Fixed DHT initialisation hang if port already in use [Parg]
BUGFIX: Core  | Don't allow prohibited peer sources to be enabled (ui artifact only) [Parg]
BUGFIX: Core  | Fixed too many socket selectors created when in safe selector mode [Nolar]
BUGFIX: Core  | Fixed re-announce interval when receiving "failure reason" error response from tracker [Nolar]
BUGFIX: Core  | Fixed and improved restarts under OSX (and linux) [Nolar,Gouss]
BUGFIX: Core  | Fixed and improved one-to-one LAN transfer speeds [Nolar]
BUGFIX: Plug  | UPnP fix for picking up changed network interfaces [Parg]
BUGFIX: UI    | Fixed 100% CPU problem with download bars [Parg]
BUGFIX: UI    | Fixed UI foregrounding itself on every unverified localhost:6880 socket connection attempt [Nolar]
BUGFIX: UI    | Create-torrent wizard fix for multi-torrent checkbox enabling error [Parg]




2005.06.27 | Azureus 2.3.0.4

FEATURE: Core | DHT torrent lookup now based on sha1(hash) and torrent xfer encrypted using hash-derived key [Parg]
FEATURE: Core | More aggressive banning of peers sending bad data - algorithm change and block-banning feature [Gudy,Parg]
FEATURE: Core | Support for multiple DHT networks on same port [Parg]
FEATURE: Core | Introduced "passive torrents" - these are tracked but not downloaded [Parg]
FEATURE: Core | Category setting functions added to "My Tracker" [Parg]
FEATURE: Core | Added ability to make plugin config ui components invisible [Parg]
FEATURE: UI   | Average peer speed for swarm column added [Nolar]
FEATURE: Plug | Plugin interface extension to allow per-plugin torrent-attributes [Parg]
FEATURE: Plug | Plugin ResourceDownload feature for accessing content-type [Parg]

CHANGE: Core  | Improved optimistic unchoke anti-leech algorithms [Nolar]
CHANGE: Core  | CVS versions run multiple DHTs to permit validations of changes [Parg]
CHANGE: Core  | DHT anti-spoof for cache forwards [Parg]
CHANGE: Core  | DHT mechanisms for flood prevention [Parg]
CHANGE: Core  | Added local tracker url to torrents when hosting external torrents [Parg]
CHANGE: Core  | Hosted torrents now become "passively tracked" when their corresponding download is removed [Parg]
CHANGE: Core  | More pro-active injection of DHT scrapes for torrents with failing trackers [Parg]
CHANGE: Plug  | More JPC plugin enhancements to help reduce cache server load [Nolar]

BUGFIX: Core  | DHT protocol version logic fixes [Parg]
BUGFIX: Core  | Fix for 100% cpu when more than 60 connections are registered with a selector under buggy network stacks [Nolar]
BUGFIX: Core  | Invalid listen port configuration would prevent Azureus from starting [Nolar]
BUGFIX: Core  | Added hooks to catch Windows shutdown events to allow graceful Azureus exit [Nolar]
BUGFIX: Core  | Fix for start-stopped non-simple torrents showing data-missing error on restart [Parg]
BUGFIX: Core  | Fix for drag-n-drop SWT exceptions blocking Azureus startup [Nolar]
BUGFIX: Core  | Fixed up "interested" message for downloads with "do not download" files [Parg,Nolar]
BUGFIX: UI    | Categories not being correctly displayed when torrents transit between downloading and seeding [Parg]



2005.05.25 | Azureus 2.3.0.2

FEATURE: UI   | Console UI now has update check, alerting and DHT stats [Parg]
FEATURE: UI   | SWT make torrent wizard remembers value for "add other hashes" [Parg]
FEATURE: UI   | Console UI logging config [Fatal]
FEATURE: Plug | Added progress indicator and torrent stats to tracker web templates [Parg, Gouss]
FEATURE: Plug | Availability column added to webui + some alignment changes [Parg]
FEATURE: Plug | XML/http interface access to individual torrent file stats added [Parg]

CHANGE: Core  | CPU usage reductions when connected to many idle peers [Nolar]
CHANGE: Core  | Disable console view logging by default [Nolar]
CHANGE: Core  | Memory usage reductions and optimizations [Gudy, Parg, Nolar]
CHANGE: Core  | Improved long-term connection-attempt management [Nolar]
CHANGE: Core  | DHT bootstrap in absence of version-check server improved [Parg]
CHANGE: Core  | DHT IP filter reports reduced [Parg]
CHANGE: Core  | Disk manager read/write threads now started on demand [Parg]
CHANGE: UI    | Default for "add other hashes" in make torrent wizard and sharing config changed to false [Parg]
CHANGE: UI    | Retention of log history removed as taking up to 1MB mem [Parg]
CHANGE: UI    | Added missing spaces back into SWT dock item's tooltip [Parg]
CHANGE: UI    | Restore version number on status bar and add protocol rate to the stats view [Nolar]
CHANGE: Plug  | JPC plugin refactoring to help reduce cache server load [Nolar]

BUGFIX: Core  | Fix compatibility with JRE 1.4 series under Win32 due to NIO bug [Nolar]
BUGFIX: Core  | Ignore peers with these data ports config option didn't work the DHT and PEX obtained peers [Nolar]
BUGFIX: Core  | DHT IP derivation from contacts fixed [Parg]



2005.05.02 | Azureus 2.3.0.0

FEATURE: Core | Client support for the 'trackerid' announce extension [Nolar]
FEATURE: Core | Client support for the 'min interval' announce extension [Nolar]
FEATURE: Core | Added options to disable scrape entirely or just for non-running torrents [Parg]
FEATURE: Core | RSS Feed parse APIs added to plugin interface [Parg]
FEATURE: Core | Non-blocking sockets based TCP tracker implementation [Parg]
FEATURE: Core | Client identification plugin interface [Parg]
FEATURE: Core | Separate protocol payload and overhead stats [Nolar]
FEATURE: Core | Data deletion can now defer to Recycle Bin and Trash under Windows and Mac OS X, respectively [Parg, CrazyAlchemist]
FEATURE: Core | Distributed Database [Parg]
FEATURE: Core | Decentralised tracking [Parg]
FEATURE: Core | Magnet URI for location of decentralised torrents [Parg]
FEATURE: Core | Ability to update built-in plugins independently of the core [Parg]
FEATURE: Core | Diagnostic collection for system properties and config settings [Parg]
FEATURE: Core | added option to move newly completed seeds to the end of the seeding list, rather than the front [Parg]
FEATURE: Core | Support for I2P plugin [Parg]
FEATURE: Core | Network selection support (public, i2p, tor) [Parg]
FEATURE: Core | Inter-client peer exchange [Nolar]
FEATURE: UI   | Option to disable small fonts under OSX [Nolar]
FEATURE: UI   | Console support for aliases [Fatal]
FEATURE: UI   | Torrent export option added to SWT UI [Parg]
FEATURE: UI   | Keyboard shortcut parsing system [CrazyAlchemist]
FEATURE: UI   | System tray menus for setting global upload and download bandwidth limits [CrazyAlchemist]
FEATURE: UI   | Synthesized speech alerts for Mac OS X; Go to Azureus / Preferences to enable it [CrazyAlchemist]
FEATURE: UI   | New file icon for Mac OS X [CrazyAlchemist]
FEATURE: Plug | Added local host configuration setting for statusmailer [Parg]
FEATURE: Plug | Reworked CSS for tracker web pages to create old and new styles [Gouss]
FEATURE: Plug | StartStop Rules: First Priority ignore Rules: 0 Peers and SeedsPeers Ratio [Gouss]
FEATURE: Plug | RSS Feed added to tracker web pages [Parg]
FEATURE: Plug | Tracker stats added to tracker web pages [Parg]
FEATURE: Plug | Generic Messaging API: inter-client message passing [Nolar]
FEATURE: Plug | Joltid Peer Cache plugin is now bundled with Azureus [Nolar, Parg, Gudy]
FEATURE: Plug | I2P plugin [Parg]

CHANGE: Core | Smarter re-announce interval handling, especially for lopsided swarms [Nolar]
CHANGE: Core | Added many new peerid identifications [Nolar, Gouss]
CHANGE: Core | First piece priority option now also prioritizes last piece of file [Nolar]
CHANGE: Core | NAT check functions even when downloads have already been started [Nolar]
CHANGE: Core | Update check can now check via configured proxy [Nolar]
CHANGE: Core | Rewritten download code: decreased cpu usage and faster speeds in LAN network environments [Nolar]
CHANGE: Core | Network IP_TOS option now sets required registry setting under Win2K/XP [Parg, Nolar]
CHANGE: Core | Favor establishing inbound peer connections, to increase the health of swarms with firewalled clients [Nolar]
CHANGE: Core | Improved seeding unchoking algorithm: distributes data more evenly [Nolar]
CHANGE: Core | Anti-leech code to prevent optimistic unchoke leechers [Nolar]
CHANGE: Core | Reduced threads required for multiple torrents [Parg]
CHANGE: Core | Relaxed cross-torrent file locking to permit multiple read access [Parg]
CHANGE: Core | changed HTTP user-agent to include OS and java version [Parg]
CHANGE: Core | max cache size limited to 32M less than VM size [Parg]
CHANGE: UI   | Reintroduced download completion alerts in Mac OS X (use System Preferences / Sound to set the alert sound of choice) [CrazyAlchemist]
CHANGE: UI   | For Mac OS X, contextual menu items no longer carry images for better compliance with Apple Human Interface Guidelines [CrazyAlchemist]
CHANGE: UI   | RFE #1092614: Informational popup messages now auto-close after 5 seconds - unless the message window is closed manually, or if the mouse is over it / details view is open (the timing will be 'reset' then) [CrazyAlchemist]
CHANGE: UI   | Miscellaneous cosmetics updates for Mac OS X [CrazyAlchemist]
CHANGE: UI   | Bug #1112278: https:// URLs now autopaste in Open URL window [CrazyAlchemist]
CHANGE: UI   | Main menu bar should now be more streamlined in its arrangement [CrazyAlchemist]
CHANGE: UI   | Console view will now display information logged (for the duration of the application session) when the Console view is closed [CrazyAlchemist]
CHANGE: UI   | ETA and remaining now take into account DHD files [Parg]
CHANGE: Plug | More choices in First Priority ShareRatio [Gouss]

BUGFIX: Core | IPFilters loaded from static config file weren't working [Parg]
BUGFIX: Core | Fix re-announce interval bug when zero peers in swarm [Nolar]
BUGFIX: Core | Send uninterested message when complete while using do-not-download feature [Nolar]
BUGFIX: Core | Optimistic Connect, when seeding, no longer drops just random connections [Nolar]
BUGFIX: Core | Better recovery from corrupt resume data [Parg]
BUGFIX: Core | Better handling of invalid torrent save locations [Parg]
BUGFIX: Core | fix for SSL (https) problems introduced by changes in JDK 5.0 [Parg]
BUGFIX: Core | fix for hash-fails when running with cache + incremental file creation enabled [Parg]
BUGFIX: Core | Fix scrape processing stall bug when scrape url was invalid [Nolar]
BUGFIX: UI   | Corrected save dialog behaviour on Make Torrent Wizard regarding file selection [CrazyAlchemist]
BUGFIX: UI   | Bug #953619 concerning Mac OS X: Double-clicking .torrent files now activate Azureus with the expected Finder dialogs (Dragging files to the Dock icon will continue to malfunction for the indefinite future) [CrazyAlchemist]
BUGFIX: UI   | Bug #1120995: Improper validation could allow unreasonably low global upload cap [CrazyAlchemist]
BUGFIX: UI   | Main window no longer tries to steal focus on opening (Mac OS X) [CrazyAlchemist]
BUGFIX: UI   | Pop up messages no longer try to steal focus (Mac OS X) [CrazyAlchemist]
BUGFIX: UI   | Resolved fuzzy dock icon display under Mac OS X if Column Setup is opened [CrazyAlchemist]
BUGFIX: UI   | Upload caps for individual transfers now display more sensible values if global upload cap is set to unlimited [CrazyAlchemist]
BUGFIX: UI   | In My Torrents, a category view will no longer prevent its corresponding table view's horizontal scrolling [CrazyAlchemist]
BUGFIX: UI   | Download bars should no longer disappear when the main window is minimized (Mac OS X) [CrazyAlchemist]
BUGFIX: UI   | Certain table column contents no longer 'disappear' when a row is selected (Mac OS X) [CrazyAlchemist]
BUGFIX: Plug | StartStop Rules: Autostart Seed Count Only and Prefer Large Swarms removed First Priority [Gouss]




2004.12.18 | Azureus 2.2.0.2

FEATURE: Core | Manual peer upload blocking (when seeding) and kick-banning [Nolar]
FEATURE: Core | Control added to not cache small files (default no cache for < 1MB) [Parg]
FEATURE: Core | Ability to cancel torrent creation processes added [Parg, Gudy]
FEATURE: Core | Ability to cancel sharing process added [Parg]
FEATURE: Core | Ability to pass multiple torrents to Azureus.exe [Parg]
FEATURE: Core | Added configuration items for tracker processing limits [Parg]
FEATURE: Core | Option to open torrent for seeding in create-torrent Wizard [Parg,Gudy]
FEATURE: Core | Auto-rescan of shared resources + addition/deletion of shares accordingly [Parg]
FEATURE: Core | Persistence of download and tracker stats for shares [Parg]
FEATURE: Core | Advanced network settings: MTU, SO_RCVBUF, SO_SNDBUF, IPTOS [Nolar]
FEATURE: Core | Optimistic Connect: drop inactive connections in order to find better ones [Nolar]
FEATURE: Core | Added ability to apply updates and shutdown Azureus instead of restarting [Parg]
FEATURE: Core | Can now specify that password protected tracker web is only available via HTTPS, HTTP access -> access denied [Parg]
FEATURE: Core | Can now specify comment to be added to share torrents [Parg]
FEATURE: Core | resume data no longer saved to torrent files, stored in %user-dir%/active instead [Parg]
FEATURE: Core | Plugin support for installing and uninstaling plugins [Parg]
FEATURE: Core | Category support for shares [Parg]
FEATURE: Core | Apply updates and defer applicaton to later restart/close [Parg/Gudy]
FEATURE: UI   | Added 'share' support to console UI [Nolar]
FEATURE: UI   | Option to show confirmation dialog on torrent Removal [Nolar]
FEATURE: UI   | Added Seed2PeerRatio item to MyTorrents view [Nolar]
FEATURE: UI   | Added detailed connection State to peers view [Nolar]
FEATURE: UI   | Added Connected Time item to peers view [Nolar]
FEATURE: UI   | Option to add torrent downloads silently (without activating main Azureus window) [Nolar]
FEATURE: UI   | Added download speed limit column to MyTorrents [Parg]
FEATURE: UI   | Telnet UI added [Fatal]
FEATURE: UI   | Auto-open stats option added [Parg]
FEATURE: UI   | Plugin install/uninstall wizards [Gudy]
FEATURE: UI   | Double click on status bar progress area to give details of update/install/uninstall progress [Parg]
FEATURE: UI   | SWT/Console share support for setting category [Parg]
FEATURE: UI   | Pick out links (anything prefixed with "http") in torrent comments in general view [Parg]
FEATURE: Plug | Status mailer support for SMTP port, user + password [Parg]
FEATURE: Plug | Status mailer support for plain text notifications [Parg]

CHANGE: Core | Support azureus.install.path parameter, used by new linux launcher script [Nolar]
CHANGE: Core | Moved config items for tracker client overrides + UDP to tracker client config [Parg]
CHANGE: Core | Also do dynamic tracker re-announce interval overrides when seeding; uses peer count only [Nolar]
CHANGE: Core | NAT check url changed to aelitis server [Nolar]
CHANGE: Core | Reduce tracker re-announce frequency when incoming connections are accepted (unfirewalled) [Nolar]
CHANGE: Core | Remove old auto-migration code [Nolar]
CHANGE: Core | Update restart logic now preserves JVM max mem setting for Sun JVMs [Parg]
CHANGE: Core | Cleanup and optimize choke-unchoke logic [Nolar]
CHANGE: Core | Added an option to enable the prioritization of most completed Files, default is off [Gudy]
CHANGE: Core | Default http tracker to disabled [Parg]
CHANGE: UI   | Create torrent wizard now initially defaults torrent save path from "save to" default [Parg]
CHANGE: UI   | Obey "start stopped" config item for dropped torrents [Parg]
CHANGE: UI   | Torrents no longer need to be stopped before removal is allowed [Nolar]
CHANGE: UI   | Graphical view item refresh optimizations [Nolar]
CHANGE: UI   | Change context menu selection for queue/stop/force-start/recheck to be "at least one can be..." rather than "all can be..." [Parg]
CHANGE: UI   | More pre-defined speed ranges for queue slot limits [Parg]
CHANGE: UI   | Improve wording of "delete torrent?" prompt [Parg]
CHANGE: Plug | UPnP information messages now off by default [Parg]

BUGFIX: Core | Fix for kernel panics under MacOSX [ej32206, Nolar]
BUGFIX: Core | Handle passing of torrents to already running but not fully initialised process better [Parg]
BUGFIX: Core | Default save dir was defaulting to ON, changed to OFF [Parg]
BUGFIX: Core | Tidied up UPnP error handing if action missing [Parg]
BUGFIX: Core | Scrape mult-tracker torrents correctly when download not running [Parg]
BUGFIX: Core | Upload/download/share ratio frig for newly added seeds made consistent [Parg]
BUGFIX: Core | Fix for stalls from system clock being set backwards in time [Nolar]
BUGFIX: Core | Fixed up bad behaviour on out-of-disk-space falures [Parg]
BUGFIX: Core | Fixed torrents getting stuck in READY state [Parg]
BUGFIX: Core | Fix potential connection establishment backlog [Nolar]
BUGFIX: Core | Fix potential DOS by timing out stalled connections [Nolar]
BUGFIX: Core | Fix bug in re-announce interval override calculation when connection limit has been reached [Nolar]
BUGFIX: Core | Fix for hangs when scraping due to slow DNS resolves [Parg]
BUGFIX: Core | Fix for UPnP failing if trailing spaces in 'action name' [Parg]
BUGFIX: Core | Fixed bug in choke/unchoke logic when number of connected peers < max upload slots [Nolar]
BUGFIX: Core | Updater problems with non-ascii chars in user dir (again!) [Parg]
BUGFIX: Core | Created torrents had name.utf-8 tag in wrong place [Parg]
BUGFIX: Core | UDP scrape responses being handled incorrectly [Parg]
BUGFIX: Core | Fixed the "high priority" piece-picking for files [Gudy]
BUGFIX: UI   | Old language files in user dir causing !missing! item texts [Nolar]
BUGFIX: UI   | Fix for window state not being remembered between sessions [Nolar]
BUGFIX: UI   | Fix for messages window being closed while animated [Gudy]
BUGFIX: UI   | Fix for BUG 1059432 : Download bars spawning multiple times when set to auto open [Gudy]
BUGFIX: UI   | Fix for BUG 1061538 : /0 error if no pieces [Parg]
BUGFIX: UI   | Fix create-torrent wizard to remember paths properly [Parg]
BUGFIX: UI   | Fixed up opening of torrent files not ending in ".tor" or ".torrent" [Parg]
BUGFIX: UI   | Fix Health icons sometimes not refreshing [Nolar]
BUGFIX: UI   | Fix bug with Azureus crashing when quitting on OSX if the Stats view has been opened [Gudy]
BUGFIX: UI   | Fix the fuzzy Azureus icon bug under OSX [Gudy]
BUGFIX: UI   | IPFilter config view slow to display when thousands of ranges are set [Gudy]
BUGGIX: UI   | Fixed bug with sharing window re-animating even when opened [Gudy]
BUGFIX: UI   | Fixed bug 1081886 : stats graphics can now be 2000 pixels wide, instead of only 1600 before [Gudy]
BUGFIX: Plug | UPnP plugin support for multi-homed machines improved [Parg]




2004.10.31 | Azureus 2.2.0.0

FEATURE: Core | Disk cache [Parg]
FEATURE: Core | Ability to set IP type-of-service (TOS) field for outbound data [Nolar]
FEATURE: Core | Show current upload and download limits in status area [Parg]
FEATURE: Core | Locale selection - options to add in all defined encodings + show lax list [Parg]
FEATURE: Core | Change the incoming data port without restarting [Parg]
FEATURE: Core | Display "warning message" responses in announce replies [Parg]
FEATURE: Core | Added option for tracker to perform a connectability check to peers [Parg]
FEATURE: Core | Have message aggregation, for bandwidth savings/efficiency [Nolar] 
FEATURE: Core | Torrent HTTP urls now accepted as program command line parameter [Nolar]
FEATURE: Core | Option added to disable system tray [Parg]
FEATURE: Core | Concurrent hashing for >1 CPU [Parg]
FEATURE: Core | Added ability to not outward connect to a defined set of port numbers [Parg]
FEATURE: Core | SOCKS V4, V4a and V5 (no auth/user+password methods) support for outgoing data connections [Parg]
FEATURE: Core | Torrents created by Azureus now include .utf-8 fields [Parg]
FEATURE: Core | Dynamic piece request queue scaling [Gudy]
FEATURE: Core | Added torrent name to authentication dialog [Parg]
FEATURE: Core | Per-torrent upload speed limits [Nolar,Gudy]
FEATURE: Core | Ability to change the sound played on torrent completion added [Parg]
FEATURE: Core | Added session uptime to stats [Nolar]
FEATURE: UI   | 'Download' menu added with start/stop all + pause/resume options [Parg]
FEATURE: UI   | Table col sort order default option added, thanks to Charnobo! [Parg]
FEATURE: UI   | URL Downloader window now support to set-up referrer and saves last used referrers [Parg, Gudy]
FEATURE: UI   | New Statistic page about the disk cache (yeah more CPU consuming graphs) [Gudy]
FEATURE: UI   | Down/Up speed indicators in main view are now double-clickable to open the Stats View [Gudy]
FEATURE: UI   | Added Path and # Remaining Pieces to Files view, Tracker Name to MyTorrents view [Nolar]
FEATURE: Plug | webui support for torrent encoding choice [Parg]
FEATURE: Plug | Tracker torrent stats available via xml/http interface [Parg]

CHANGE: Core | Show time to re-announce/scrape in general view using hh::mm::ss [Parg]
CHANGE: Core | Timeout tracker server operations [Parg]
CHANGE: Core | Torrent opener will now report errors opening torrents better [Parg]
CHANGE: Core | Complete core networking/messaging rewrite [Nolar]
CHANGE: Core | Stop scrape on UDP V2 torrents when download running [Parg]
CHANGE: Core | Refactor of DiskManager [Parg]
CHANGE: Core | Protocol tweaking for significantly reduced discard rates [Nolar]
CHANGE: Core | Tracker now treats port value of 0 as 'explicitly firewalled' [Parg]
CHANGE: Core | Tracker client will revert to "initialised" state after explicit failure from tracker [Parg]
CHANGE: Core | Locale selection changed to show more possible encodings [Parg]
CHANGE: Core | XML stats - downloads ordered by downloading/index then seeding/index [Parg]
CHANGE: Core | Reworked connection establishment to conform to new WinXP SP2 limits [Nolar]
CHANGE: Core | When restarting torrents are checked in smallest->largest size [Parg]
CHANGE: Core | Reworked the piece picking so that slow peers don't "block" pieces to be completed [Gudy]
CHANGE: Core | JAR signing for webui (etc) now based on "tools.jar" from Sun JDK due to changes with their 1.5 JRE [Parg]
CHANGE: Core | "Pause" command now greyed out if there is nothing to pause [Parg]
CHANGE: Core | Create-torrent wizard now remembers comment data on back button + defaults for open/save dirs [Parg]
CHANGE: Core | Reduced memory used of ipfilter list to help support large list sizes [Parg]
CHANGE: Core | Added "*.*" to list of selectable file types in open-torrent dialogs [Parg]
CHANGE: UI   | Added a legend to the Pieces View [Gudy]
CHANGE: UI   | Pieces View now display if the blocks are in the cache or not [Gudy]
CHANGE: UI   | New Tools menu, Configuration --> Options, Plugins root menu, Language selection moved to config [Nolar,Gudy]
CHANGE: Plug | UPnP plugin now only uses plugin interfaces [Parg]
CHANGE: Plug | Differentiate UDP and TCP mappings in UPnP desc as some routers need this [Parg]
CHANGE: Plug | UpdateLanguagePlugin removed, as no longer maintained [Nolar]

BUGFIX: Core | Throw an error message if existing data file length is too large [Nolar]
BUGFIX: Core | Fix new bug with tracker announce every 10s when no peers were connected [Nolar]
BUGFIX: Core | Fix for renaming files across volumes [Parg]
BUGFIX: Core | Torrent auto-import now works with console UI [Nolar]
BUGFIX: Core | Bug when setting upload to unlimited (forced download to unlimited too) [Parg]
BUGFIX: Core | Set downloaded amount correctly when opening a torrent with existing download data [Parg]
BUGFIX: Core | Detect changed file sizes (smaller) when resuming torrents [Parg]
BUGFIX: Core | Random shuffling of multi-tracker torrent URLs fixed [Parg]
BUGFIX: Core | Fix occasional 60sec delay on initial tracker announce [Nolar]
BUGFIX: Core | Fix for reading piece data from a too-long file [Nolar/Parg]
BUGFIX: Core | Stop scraping all announce URLs in a torrent when removing torrent [Parg]
BUGFIX: Core | File handle closing [Parg/Nolar]
BUGFIX: UI   | Labels with '&' displaying incorrectly [Parg]
BUGFIX: UI   | Torrent Downloader Window : retry button now placed correctly [Gudy]
BUGFIX: UI   | Fix for clicking the plugins directory and open the folder from the Configuration>Plugins view [Gudy]
BUGFIX: UI   | Fix for animated message windows not being at the right place on dual monitors. [Gudy,Bluelive]
BUGFIX: Plug | Netgear WGT624 was crashing when processing UPnP requests [Parg]
BUGFIX: Plug | Webui 'view' mode wasn't working [Parg]
BUGFIX: Plug | Webui - excessively long status text messing up table [Parg]
BUGFIX: Plug | azplugins - web tracker pages wasn't picking up "show details" option [Parg]
BUGFIX: Plug | webui - fixed bug with re-ordering of columns [Parg]




2004.07.08 | Azureus 2.1.0.4

FEATURE: Core | Show built-in plugins in config view [Parg]
FEATURE: Core | Fallback encoding for torrents (a-zA-Z0-9 type encoding with hex chars for others) [Parg]
FEATURE: Core | Numbers now localized to selected language [TuxPaper]
FEATURE: Core | More "polite" hash checking...doesn't stress the cpu/system as much [Nolar]
FEATURE: Core | Tracker seed retention limit added to limit tracker memory on torrents with high seed counts [Parg]
FEATURE: Core | Show Bad ips/banned ips in ipfilter window + allow clear/reset [Parg]
FEATURE: Core | Option to start torrents in a stopped state [Parg]
FEATURE: Core | Torrent removal rules. Initially to handle unauthorised torrents + AZ update torrents [Parg]
FEATURE: Dev  | More features for torrent creation [Parg]
FEATURE: UI   | New peer columns to help track leechers [TuxPaper]
FEATURE: Plug | Experimental data upload facility for tracker web pages [Parg]
FEATURE: Plug | WebUI support for "host" operation [Parg]
FEATURE: Plug | Run the web interface standalone (outside of a browser) [Parg]
FEATURE: Plug | Option to keep hold of UPnP port mappings when closing Azureus [Parg]

CHANGE: Core | More sensible merging of plugin.properties on plugin update [Parg]
CHANGE: Core | Retuned tracker connect failure retry interval [Nolar]
CHANGE: Core | Torrents downloaded by URL now named after torrent if not already .torrent [Parg]
CHANGE: Core | Performance of ipfilter checking improved [Parg]
CHANGE: Plug | Green colour used on tracker web pages now more legible [Nolar]

BUGFIX: Core | 99.X% / continuous hash fails fix [Parg]
BUGFIX: Core | Basic plugin config model parameters not working in non-swt (e.g. console) mode [Parg]
BUGFIX: Core | Fix for 'completed' announce event not being sent on occasion [Nolar]
BUGFIX: Core | Fix for occassional missing of resume data write -> recheck on start up [Parg]
BUGFIX: Core | Bad peers not being detected on hashfail if they contributed all blocks [Parg]
BUGFIX: Core | Better handling of "auto import" + default torrent save dir being the same [Parg]
BUGFIX: Core | Strip resume data on open of new torrent [Parg]
BUGFIX: UI   | Fix bug where failed-hashcheck pieces never reappeared in Pieces view [Nolar]
BUGFIX: Plug | Web UI authentication for torrent download not working with default port URLs [Parg]



2004.06.21 | Azureus 2.1.0.2

FEATURE: Core | Health items now show if a torrent is being shared/published [Parg]
FEATURE: Core | Creation of self-signed certificates for SSL (etc) via UI [Parg]
FEATURE: Core | Set download speed per torrent [Parg]
FEATURE: Core | Universal Plugin and Play (UPnP) support [Parg]
FEATURE: Dev  | ToolTip access functions for table cells [TuxPaper]
FEATURE: Plug | Tracker plugin supports simple category view [Parg]
FEATURE: Plug | Webui support for password protected trackers [Parg]
FEATURE: Plug | Webui attempts to get access to system clipboard to fix copy/paste issues [Parg]
FEATURE: Plug | Plugin interface extensions for basic plugin config [Parg]
FEATURE: Plug | External authorisation framework [Parg]
FEATURE: Plug | WebUI + XML/HTTP i/f now have separately configurable username/password via Plugin config (*not* plugin.properties) [Parg]
FEATURE: Plug | WebUI can now use signed jars, if configured, so that clipboard access doesn't require local config [Parg]
FEATURE: UI   | Better scrape result reporting, including new "Next Tracker Access" column [TuxPaper]
FEATURE: UI   | Tooltip for Health Icon [TuxPaper]
FEATURE: UI   | New language: Japanese [Gouss]

CHANGE: Core | Core update checker now uses aelitis.com server to grab latest version instead of SF's one [Gudy]
CHANGE: Core | Default socket write buffer now a more conservative 1460 bytes for smoother uploading [Nolar]
CHANGE: Core | Central control of global outgoing peer connection rates...i.e. a better SlowConnect [Nolar]
CHANGE: Core | Unused potential peer connections are cached for later use [Nolar]
CHANGE: Core | Tracker now doesn't return peer list on "stopped" event [Parg]
CHANGE: Plug | Tracker web plugin configuration moved to plugin config from core config  [Parg]
CHANGE: Plug | Tracker web contexts now have the option to not apply IP Filters - this affects the web plugin and xml/http interface [Parg]
CHANGE: UI   | About Window is closeable by hitting the 'ESC' key [Gudy]

BUGFIX: Core | Fix for Library Paths using single quotes [Parg]
BUGFIX: Core | Fixed shared plugin dir location on OSX [Parg]
BUGFIX: Core | File Open dialogs now correctly remember their last path [Nolar]
BUGFIX: Core | Plugin loader picking up .zip files instead of corresponding .jar files [Parg]
BUGFIX: Core | Don't delete the imported .torrent file if the import dir happens to also be the Save torrent dir [Nolar]
BUGFIX: Core | Torrents leave READY state quicker after other torrents are re-queued [TuxPaper]
BUGFIX: Core | Fix for Fast Resume not working when a 0-byte file exists in the torrent [Nolar]
BUGIFX: Core | Fix for Fast Resume not working when Incremental File Creation is enabled [Nolar]
BUGFIX: Core | Show error message if previously-allocated data cannot be found, instead of re-creating it [Nolar]
BUGFIX: Core | Force a file handle recycle every 50M read so the OS cache clears (Win2k, possibly other OSes) [TuxPaper]
BUGFIX: Core | Tracker stats wrong [Parg]
BUGFIX: Core | Not deleting backup torrents (.bak) when MyTorrent->remove + delete [Parg]
BUGFIX: UI   | # Column now on by default again [TuxPaper]
BUGFIX: UI   | Fix for Bug #966867: Context Menu not appearing after setting up columns on Linux [TuxPaper]
BUGFIX: UI   | IP column now sorts by hex groups [TuxPaper]
BUGFIX: UI   | Fix for .torrent icons with new Azureus.exe [Parg]
BUGFIX: UI   | Fix for text color on some Table cells not moving when row moved [TuxPaper]
BUGFIX: UI   | Moving torrent from Uncategorized category to new category now removes the row from the display [TuxPaper]
BUGFIX: UI   | Fix for empty table rows appearing in Peers Details tab and Pieces tab [TuxPaper]
BUGFIX: UI   | Windows : Tray Icon should come back after explorer crash (needs latest SWT build) [SWT team, Gudy]
BUGFIX: UI   | 192 bytes memory leak fixed on OSX [SWT Team, Gudy]



30.05.04 | Azureus 2.1.0.0

FEATURE: Core | Ability to limit global download speed [Parg]
FEATURE: Core | Added ability to automatically exclude files when making torrents (e.g. .DS_Store & Thumbs.db) [Parg]
FEATURE: Core | Caching of peer info to disk for quick restarts if tracker is unavailable [Parg]
FEATURE: Core | Detection of plugin updates [Parg]
FEATURE: Core | HTTP scrapes to same tracker combined into one request if tracker supports it [TuxPaper]
FEATURE: Core | Support for scraping trackers like http://tracker.boxtorrents.com:6969/ that scrape with /scrape but don't have "announce" in announce URL [Parg]
FEATURE: Core | Tracker connections proxy support (peer connections not supported yet) [Nolar]
FEATURE: Core | UDP authentication protocol added [Parg]
FEATURE: Core | UDP tracker version 2 support added [Parg]
FEATURE: Core | Generic update mechanisms for core, updater and swt [Parg/Gudy]
FEATURE: Core | Support for loading user-specific plugins from user dir and shared ones from app dir [Parg]
FEATURE: Dev  | Column management for any of Azureus' table views. [TuxPaper]
FEATURE: Dev  | Easy to use "basic plugin view": see PluginInterface::getUIManager::getBasicPluginViewModel [Parg, Gudy]
FEATURE: UI   | Ability to upload torrents with xml/http interface [Parg]
FEATURE: UI   | All columns sortable and configurable [TuxPaper]
FEATURE: UI   | Added "Remaining", "DLing For" (time) and "Seeding For" (time) columns to "My Torrents" [TuxPaper]
FEATURE: UI   | Added option to auto-update language file from web (Config -> Interface -> Language) [TuxPaper]
FEATURE: UI   | Added option to show transfer rates in bits/sec [Parg]
FEATURE: UI   | In the Details view, the peer's pieces that we already have are shown in a faded color [TuxPaper]
FEATURE: UI   | Linux system tray support [Gudy]
FEATURE: UI   | MyTracker row right-click support for copying torrent URL to clipboard [Parg]
FEATURE: UI   | Right-click menu sorting of columns (Sorting for OSX) [TuxPaper]
FEATURE: UI   | Send text in My Torrents to clipboard [TuxPaper]
FEATURE: UI   | When torrent data is missing, you can change directory via the context menu [TuxPaper]
FEATURE: UI   | OSX : About and Preferences items are listed under 'Azureus' menu [Gudy]
FEATURE: UI   | Added an option not to use units bigger than MB [Gudy]
FEATURE: UI   | Option to show peer host names instead of IP address [Parg]
FEATURE: UI   | Embedded tracker IP blocks shown in Blocked IPs List [Parg]
FEATURE: WebUI| Web Plugin now can set upload rate [Parg]
FEATURE: WebUI| Web Plugin support for uploading torrents [Parg]
FEATURE: WebUI| Webui + xml/http "access" property support for IP range [Parg]
FEATURE: WebUI| Webui + xml/http plugins have had basic plugin view added [Parg]

CHANGE:      | IRC and Tracker Web Pages moved to separate plugin [Parg]
CHANGE: Core | Auto-imported .torrent files are moved (not copied) to default .torrent save dir if enabled [Nolar]
CHANGE: Core | Auto-imported .torrent files are renamed *.imported if default .torrent save dir is not enabled [Nolar]
CHANGE: Core | Can set per-torrent and global peer connection limits [Nolar]
CHANGE: Core | Config/pref/torrent file saving uses intermediate .saving file for more reliability [Nolar]
CHANGE: Core | Currently-connected peer connections are dropped when IPFilter is enabled [Nolar]
CHANGE: Core | File descriptor handles increased from default of 256 to 8192 under OSX [Nolar]
CHANGE: Core | Ignore Share Ratio can now be non-integer [TuxPaper]
CHANGE: Core | New SHA-1 hasher: up to 25% faster [Gudy / Nolar]
CHANGE: Core | Scrape interval now based on # of seeds (15min minimum) [TuxPaper]
CHANGE: Core | Socket writes now done in full MSS-sized chunks [Nolar]
CHANGE: Core | Upload limit can now be set less than 5KB/sec. However, doing so limits download speed too [Parg]
CHANGE: Core | User config/pref/plugins dir culled from Windows' Registry (needs aereg.dll) [Parg]
CHANGE: Core | OSX user- pref/plugin dir moved from ~/Library/Azureus/ to ~/Library/Application Support/Azureus/ to meet osx standards [Nolar]
CHANGE: Core | Unix user- pref/plugin dir moved from ~/Azureus/ to ~/.Azureus/ to meet unix standards [Nolar]
CHANGE: UI   | All progress/piece bars re-done (again) [TuxPaper]
CHANGE: UI   | Azureus should work with SWT 2.12 until we break backwards compat. again [TuxPaper]
CHANGE: UI   | Shrink "My Torrents" Context menu [TuxPaper]
CHANGE: UI   | Systray4j removed: system tray support now from SWT built-in code (Requires SWT-M8+) [Gudy]
CHANGE: UI   | Torrent name shown with IPs in the blocked-IPFilter list [Nolar]
CHANGE: UI   | The Donation Window is now Closeable using the 'Esc' Key [Gudy]
CHANGE: UI   | In the Donation Window the OK button should be on top of other Controls [Gudy]
CHANGE: UI   | Added a "what's new" item in help menu, pointing to changelog for current version [Gudy / Gouss]

BUGFIX: Core | Files incorrectly shared if contents not a torrent when opening [Parg]
BUGFIX: Core | First Priority rules based on time now work across sessions [TuxPaper]
BUGFIX: Core | Fix for saving of .torrent file in wrong dir: Bug #916137 [Nolar]
BUGFIX: Core | Fix for some discarded data due to occasional duplicate request [Nolar]
BUGFIX: Core | Fix for system clock changes stalling downloads: Bug #918193 [Nolar]
BUGFIX: Core | Fix for system clock running faster when using Azureus [Nolar]
BUGFIX: Core | Fix for underlying socket handles not closing under linux ("Too many open files") [Nolar]
BUGFIX: Core | Individual file priorities remembered after Stop-Start [Nolar]
BUGFIX: Core | Multiple shares of same resources causing problems (e.g. share contents+share contents recursive of same dir) [Parg]
BUGFIX: Core | Simpler and more reliable file allocation...won't b0rk existing data [Nolar]
BUGFIX: Core | Re-check on completion no longer sends Have messages [Nolar]
BUGFIX: UI   | Fix for the General View in a torrent details, not being layout correctly [Gudy]
BUGFIX: UI   | Fix for the toolbar on linux / OS X [Gudy]
BUGFIX: UI   | Fix for the Torrent Maker not getting the correct Tracker when choosing from the Combo on OS X [Gudy]
BUGFIX: UI   | Fix for the Freeze on exit under OSX [Gudy]





16.03.04 | Azureus 2.0.8.4

CHANGE: WebUI plugin included in mainline (see http://azureus.sf.net/CVS/web.interface.howto.htm) [Parg]
CHANGE: Much more reliable SF mirror auto-update handling [Nolar]

BUGFIX: Fix for loading .torrent files via web-browser/shell/doubleclick/etc [Nolar]



15.03.04 | Azureus 2.0.8.2

FEATURE: Show last time IPFilter list was updated in status area [Parg]
FEATURE: Support for "compact" tracker announce protocol [Parg]
FEATURE: Support for "key" tracker announce protocol [Parg]
FEATURE: Download Speed column in "My Torrents" turns red if below speed set in Queue config. [TuxPaper]
FEATURE: Webplugin swing ui has status area with total ul/dl [Parg]
FEATURE: XML over HTTP remote plugin interface (initially to support GTS) - mail parg@users.sf.net for details [Parg]

CHANGE: All config/pref files utilize .bak backup files [Parg]
CHANGE: Option to limit outstanding disk writes and piece hash checks [Parg]
CHANGE: Can delete shares in QUEUED state [Parg]

BUGFIX: Fix of startup issues under Win95/98/Me [TuxPaper]
BUGFIX: Locale-specific dir creation [Parg]
BUGFIX: Hebrew language works now [TuxPaper]
BUGFIX: Fixed long load times under Linux of Configuration view and General tab [TuxPaper]
BUGFIX: Popup windows now center in main monitor on multi-monitor setups [TuxPaper]
BUGFIX: Fix for Pieces and Files views off-by-one row drawing glitch under linux [TuxPaper]
BUGFIX: Sort on Health and Availability now enabled [TuxPaper]
BUGFIX: Various memory leaks (DiskManager instances not being freed) [Parg]



08.03.04 | Azureus 2.0.8.0

FEATURE: QUEUED status. Torrents that are queued are stopped, but available for automatic starting [TuxPaper]
FEATURE: Partial support for Read-Only data (for seeding) [TuxPaper]
FEATURE: Added "Forced-Start" to force a torrent to start, ignoring download limits or seeding rules [TuxPaper]
FEATURE: Auto-positioning of finished torrent based on how badly the torrent needs seeding [TuxPaper]
FEATURE: Added Availability, Seeding Rank, SavePath, Max # Uploads, and Total Speed columns to My Torrents view [TuxPaper]
FEATURE: Categories to group your torrents in (right click on My Torrents and select Set Category to get started) [TuxPaper]
FEATURE: More auto-seeding options [TuxPaper]
FEATURE: Ability to limit maximum number of file handles open/in-use at any given time [Parg]
FEATURE: Tracker - various performance enhancements such as announce/scrape caching. Tested to 500,000 peers on single torrent [Parg]
FEATURE: Tracker activity logging to %azhome%/tracker.log [Parg]
FEATURE: Tracker bytes in/out + scrapes recorded [Parg]
FEATURE: Tracker - ability to limit number of peers returned [Parg]
FEATURE: Share ratio now shown on tracker web pages [Parg]
FEATURE: Tracker/client support for "no_peer_id" spec for bandwidth savings [Parg/Nolar]
FEATURE: More plugin stuff - alert raising, ipfilter reloading, various other stuff [Parg]
FEATURE: Applet UI enhanced into usable state (start/stop/add/remove downloads) + auto refresh [Parg]
FEATURE: Added torrent hashes for G2 + ED2K (ala http://www.torrentaid.com/) [ Parg]
FEATURE: Added colours to file view to show: grey -> requested; red -> data recently written [Parg]

CHANGE: Split torrents in My Torrents view into 2 lists: Downloading and Seeding (Completed) [TuxPaper]
CHANGE: STOPPED status now means the torrent never auto-starts [TuxPaper]
CHANGE: Moved icon from Rank column to Name column [TuxPaper]
CHANGE: Removed Lock Priority.  No longer an issue since priority only gets autochanged once [TuxPaper]
CHANGE: Remove "Lock Start/Stop" menu option.  Stop now means no auto-starting/stopping [TuxPaper]
CHANGE: Re-design of Configuration view [TuxPaper]
CHANGE: Language files (MessagesBundle_xx_XX.properties) are read in the following order: Azureus user directory, Azureus application directory, JAR file [TuxPaper]
CHANGE: Remember sorted column and order for all views [TuxPaper]
CHANGE: Core performance optimizations and major cpu usage reductions [Nolar]
CHANGE: User prompt when (1) tracker listens fails (2) incoming server port bind fails [Parg]
CHANGE: Config files/dirs and plugins now stored in OS user dir (Win: C:\Documents and Settings\username\Application Data\Azureus\, OSX: /Users/username/Library/Azureus/, Linux: /home/username/Azureus/) [Nolar]
CHANGE: Tracker log now includes date as well as time [Parg]

BUGFIX: Once a torrent is complete, and you remove the data, it wil no longer start downloading again when seeding rules are on [TuxPaper]
BUGFIX: 1st column of MyTorrents no longer has a gap if there's no icon. (Windows Only Bug) [TuxPaper]
BUGFIX: Fix for download stalls at 99% / 100% cpu usage bug introduced in 2070 [Parg/Gudy] 
BUGFIX: Fix for minimize/close causing the program to disappear from view under OSX [Nolar]
BUGFIX: Fix for icon bar buttons not being flat (Bug #890166) [Gudy]
BUGFIX: More reliable .config and .torrent file save/load management [Nolar]
BUGFIX: Better handling of failures when performing "move on complete" [Parg]
BUGFIX: Handle torrent file names with trailing spaces and CR/NL (from Mac) [Parg]


02.02.04 | Azureus 2.0.7.0

FEATURE: Under Linux + GTK, added an option to setup a vertical offset to re-align graphics [Gudy]
FEATURE: SSL tracker client now gives option to import certificate rather than manually doing so via "keytool" [Parg]
FEATURE: Start All Downloads option on tray icon [Nolar]
FEATURE: Support for trackers that do not return peerIDs on announce [Parg]
FEATURE: Sharing - allows files/dirs/dir contents (recursive) to automatically have torrents created for them and torrents hosted
		 The shared resources will automatically have their torrents recalculated if they change (over Azureus restart) [Parg]
FEATURE: Tracker allows number of peers returned to be limited [Parg]
FEATURE: Experimental UDP tracker protocol (see Config->Tracker->Extensions). Azureus client/tracker supports this, as does the XBT tracker (http://sourceforge.net/projects/xbtt/) [Parg]
FEATURE: Tracker support for GZIP encoding [Parg]
FEATURE: Tracker support for multiple pages [IAmChrist]
FEATURE: Tracker pages skinable by placing pages in %azhome%/web [Parg]
FEATURE: Major extensions to plugin interfaces [Parg]
FEATURE: Simple Swing based remote admin interface (over SSL+password auth) - email parg@users.sourceforge.net for details [Parg]
FEATURE: Click on hash in general view to copy hash to clipboard [Parg]

CHANGE: Azureus now identifies itself via User-Agent in tracker http communications [Nolar]
CHANGE: Less flickering, on all platforms (tested on both windows and linux+GTK) [Gudy]
CHANGE: Azureus now responds as Server: Azureus <version> in tracker http comms [Parg]
CHANGE: Unwritten blocks in Pieces view shown in red [Gijs Overvliet]
CHANGE: Prioritizing first piece of file(s) now optional in config [Nolar]
CHANGE: Confirmation on data deletion now optional in config [Nolar]
CHANGE: More intelligent announce url '&numwant=' handling [Nolar]
CHANGE: On tracker announce errors, retry interval now uses exponential backoff [Nolar]
CHANGE: Removed multi-port listening, as shared single port is far superior [Nolar]
CHANGE: More reliable .config and .torrent file writing [Nolar]
CHANGE: Tracker scraper now honors a 'flags: min_request_interval' response [TuxPaper]
CHANGE: Plugins can be initialised from plugin.properties freestanding (not just in .jar file) [Parg]

BUGFIX: Problem with tracker not responding with "Connection: close" causing SSL session maintainance with HttpsURLConnection to stuff up and fail clients with "recv fail" [Parg]
BUGFIX: Fast resuming with Chinese directories: Bug #869749 [Parg]
BUGFIX: System tray icon re-shown after explorer.exe crash (again) [Rele]
BUGFIX: Fix for potential memory leaks [Nolar]
BUGFIX: Fix for stalled piece writing [Gijs Overvliet]
BUGFIX: Fix for .torrent file data not being fully written on shutdown [Parg]
BUGFIX: Fix for OutOfMemoryError in DiskManager: Bug #865553 [TuxPaper]
BUGFIX: Fix for 'Open a URL' downloading of .torrent file which contains white spaces: Bug #878990 [Parg]
BUGFIX: Fix for Fast Resume with Chinese torrents: Bug #878015 [Parg]
BUGFIX: Fix for excess thread creation when tracker does not support single-infohash scrapes [Nolar]
BUGFIX: Fix for hash checking 0-byte files: Bug #853126 [Nolar]
BUGFIX: Fix for opening files via Files tab when using MoveOnComplete: Bugs #860822, #878795 [Nolar] 
BUGFIX: Fix for 100% cpu usage after network disconnect/reconnect: Bugs #873957, #879498 [Nolar]
BUGFIX: Fix for downloaded blocks not being written to disk, due to write-thread stall under high load [Nolar]
BUGFIX: Fix for various non-unicode torrent encoding issues regarding resume data [Parg]



19.12.03 | Azureus 2.0.6.0

FEATURE: Intelligent Tracker Checking: optimizes tracker re-ask interval for quicker download speed ramp up [Nolar]
FEATURE: Azureus can now run all downloads off one shared incoming port: only need to open/forward one port in your firewall/NAT [Parg]
FEATURE: Drag-n-Drop moving of downloads in MyTorrents; moving of downloads in MyTorrents with Ctrl + Arrow-Up/Down [Rele]
FEATURE: Password protected access to tracker web and torrents [Parg]
FEATURE: GUI Update interval is configurable [Gudy]
FEATURE: Images update interval is configurable [Gudy]
FEATURE: Auto sort on tables possible, interval configurable [Gudy]
FEATURE: MyTorrents view can now be customized (choice of columns and order) [Gudy]
FEATURE: Added new columns to MyTorrents : 'Share Ratio', 'Downloaded', 'Uploaded', 'Health' [Gudy]
FEATURE: Details view can now be customized (choice of columns and order) [Gudy]
FEATURE: SSL now supported for tracker web and tracker updates [Parg]
FEATURE: Added Drag and Drop of URLs [Rele]
FEATURE: Multi-Trackers torrents can now be created/edited [Gudy]
FEATURE: Menu option to force a re-check of downloaded data [Nolar]
FEATURE: End-Game Mode: Completes the last few pieces of a download faster [Gudy]
FEATURE: Attempts to download the very beginning of a file first - to support previewing [Nolar]
FEATURE: IPFiltering stats shown in status bar [Gudy]
FEATURE: Toolbar! [Gudy]
FEATURE: Logging of console output to disk [Parg]
FEATURE: Option to confirm on exit [Rele]
FEATURE: Bad Peer Detection [Gudy]
FEATURE: Inclusion of XSL stylesheed tag in stats XML file [Parg]
FEATURE: Editing and selection of tracker announce URLs from general view [Gudy]
FEATURE: Plugin interface for tracker web serving [Parg]
FEATURE: HTML template (http://html-tmpl-java.sourceforge.net/) support for tracker web serving from %az_home%/web folder [Parg]
FEATURE: Opening a second torrent with same hash as existing download causes second torrent's announce urls to be merged into the first [Parg]
FEATURE: Option to not accept multiple connections from the same IP [Gudy]
FEATURE: Option to use the IP Filter list as an 'ALLOW' list [Gudy]
FEATURE: Super-Seed Mode [Gudy]
FEATURE: Pressing a character selects the next download with a name beginning with this character in MyTorrents view [Rele]
FEATURE: Option to move-on-complete only when data is inside the default save dir [Nolar]
FEATURE: Auto-import new .torrents from a chosen folder regularly [Rele]
FEATURE: Create torrent allows manual piece size selection [Parg]
FEATURE: New 'Activity' view (download and upload speed graphics) [Gudy]
FEATURE: Gzip encoding support for tracker announces [Parg]
FEATURE: Tray icon: added Stop All Torrents [Rele]
FEATURE: If .torrents are dropped in COPY state (with modifier key Ctrl under Windows), they will begin in STOPPED state [Rele]
FEATURE: Ctrl + [Home/End/CursorUp/CursorDown] moves selected torrents to top/end/up/down, "Del" removes selected torrents [Rele]
FEATURE: Ctrl + [S/R] stops/resumes(starts) selected torrents, Ctrl+Shift+S stops all torrents, Ctrl+A selects all torrents [Rele]
FEATURE: Option to backup .torrent files [Rele]
FEATURE: Option to play a sound on download finish [Rele]
FEATURE: Download Basket: TrayWindow always visible for Drag-n-Drop of .torrents [Rele]
FEATURE: Clickable Tracker URL in Details/General copies the announce URL into clipboard [Rele]
FEATURE: Tab hot keys: F6 selects next Tab, Shift+F6 selects previous Tab, ESC or CTRL+F4 closes current Tab [Rele]
FEATURE: Extended Plugin interface [Parg,Gudy]

CHANGE: 'Bind to local IP address' now binds outbound sockets as well [Nolar]
CHANGE: Status now shows when it is re-checking pieces on download completion [Nolar]
CHANGE: URL dialogs are initialized with the first valid link beginning with http:// from clipboard [Rele]
CHANGE: Under linux, only use ~/.azureus dir if it already exists, otherwise use normal program dir for files [Nolar] 
CHANGE: Auto-update: now writes a log to an 'update.log' file [Nolar]
CHANGE: Option to disconnect seeds when seeding is now checked by default [Gudy]
CHANGE: FilesView now shows files even in other states than Downloading (configurable) [Rele]
CHANGE: Updated/additional menu buttons [Gudy]
CHANGE: Some speed optimizations with piece-picking [Nolar]
CHANGE: Generated PeerID only uses chars that don't need to be escaped, saving bandwidth for tracker communications [Nolar]
CHANGE: Can now identify BitComet, TurboBT, LibTorrent clients [Nolar]
CHANGE: Support for both SI byte units (KiB,MiB,GiB) and more well known, but incorrect KB/MB/GB units via config Interface param [Parg]
CHANGE: locale choice can force prompt via new config param on "File" tab [Parg]

BUGFIX: 'Re-check pieces when done' now always ignores fast-resume data: Bug #825881 [Nolar]
BUGFIX: Fix some decoding bugs in Chinese torrent files due to missing locale encodings in dialog box [Akilgard]
BUGFIX: System tray icon re-shown after explorer.exe crash [Rele]
BUGFIX: Completed downloads shown in different color when Stopped [Nolar]
BUGFIX: Fix possible data loss when moving complete files if not enough free space avail: Bug #855284 [Nolar]
BUGFIX: Fix for the incremental vs allocate choice in Config [Gudy]
BUGFIX: DNS lookups are no longer cached for ever [Parg]
BUGFIX: OSX: Hang when closing: Bug #824459 [Nhilep]


20.11.03 | Azureus 2.0.4.2

FEATURE: Added tooltip general support [Gudy]
FEATURE: Default torrent encoding selection added to Config->File [Parg]
FEATURE: Public tracker support - config item allows external use of tracker [Parg]

CHANGE: Full scrape of embedded tracker now supported as SN requires this for hosting [Parg]
CHANGE: Better peer client identification [Nolar]
CHANGE: Added AZ version + torrent size to stats [Parg]
CHANGE: Added 'comment' field to torrent create [Parg]
CHANGE: Moving of .torrent to completed dir now optional [Nolar]
CHANGE: Additional upload speed options [Nolar]
CHANGE: Cleanup of Configuration tabs [Nolar]
CHANGE: Rewrite of locale selection code for torrents. Only one encoding allowed per torrent [Parg]
CHANGE: File->Open... now opens to the default download/torrent dirs set in config [Parg]
CHANGE: ETA/TimeRemaining now uses just two significant measures, and "kB" changed to "KB"  [Nolar] 

BUGFIX: Torrent hosting - resetting of tracker url to original after hosting cancelled [Parg]
BUGFIX: Allow for torrent files with '.tor' extention [Nolar]
BUGFIX: Renamed file not reused after torrent Stop-Start: Bug #842750 [Nolar]
BUGFIX: No longer deletes files if the 'completed' dir points to the download dir: Bug #842896 [Nolar]
BUGFIX: Fast resume data no longer duplicated [Nolar]
BUGFIX: File 'downloads.config' kept better up-to-date [Nolar]
BUGFIX: % Completed is now correct again in MyTorrents view on stopped downloads [Gudy]
BUGFIX: Non-UTF8 encoded 'comment' fields in torrents not showing properly [Parg]
BUGFIX: Some dead-lock issues (especially on startup) [Gudy]
BUGFIX: Better recovery on connection closing [Nolar]
BUGFIX: Uncleaned buffers in peer handling code [Nolar]
BUGFIX: Outgoing message correctness verification [Nolar]
BUGFIX: Text scroll is now ok in irc view [Gudy]
BUGFIX: Size is now displayed even when the torrent is stopped [Gudy]
BUGFIX: Sorting by 'Discarded', 'Overall Down Speed', 'Stat Up' in Details view [Nolar]
BUGFIX: Torrent 'discarded' and 'hash fails' now remembered between sessions [Nolar]
BUGFIX: Corrected sorting by DownSpeed, UpSpeed, ETA in MyTorrents view [Nolar]
BUXFIX: Irc input text area gets focus correctly now [Gudy]
BUXFIX: On Windows bundle, systray4.dll as been updated to support chinese characters [evilcai]



13.11.03 | Azureus 2.0.4.0

FEATURE: Disable (per torrent) the auto priority setting when seeding [Gudy]
FEATURE: Disable (per torrent) the rules to start / stop a seeding torrent [Gudy]
FEATURE: Move files to a directory upon completion [Nolar]
FEATURE: Slowly establish new connections to peers (for those with internet disconnection issues) [Nolar]
FEATURE: Bind to local IP address [Nolar]
FEATURE: Export/import torrent file to/from XML file [Parg]
FEATURE: Export of runtime statistics to XML file [Parg]
FEATURE: Hosting of torrents using built-in tracker [Parg]
FEATURE: Trackers used in the 'make torrent' wizard are now remembered.
FEATURE: Embedded tracker [Parg]
FEATURE: Enhanced peer client identification [Nolar]
FEATURE: Publishing of torrents to tracker (as opposed to hosting them) [Parg]
FEATURE: Choosable color for the progress bars [Gudy]
FEATURE: Plugin support [Gudy]
FEATURE: Open a torrent file without using the default save location [Gudy]
FEATURE: Added a FAQ and a Donate link in Help menu [Gudy]
FEATURE: New languages : Brazilian-Portuguese, Czech, Lithuanian [Gouss - Translators]

CHANGE: Some GUI Changes, so that SWT WinXP theme is better supported [Gudy]
CHANGE: Saving of torrent files to central dir now optional [Nolar]
CHANGE: Checking after crash now remembers Fast Resume data [Nolar]
CHANGE: Internal refactorization of core classes [Parg]
CHANGE: More logging of reasons for connection closed [Gudy]

BUGFIX: Fixed snub/unsnub multiple peers on the peers list [Gudy]
BUGFIX: Save file dialog now opens as a 'save' dialog, and not 'open' (for OSX) [Gudy]
BUGFIX: DNS name resolution caching no longer infinite [Nolar]
BUGFIX: Better recovery checking of partially-allocated files [Nolar]
BUGFIX: Re-check file(s) integrity after completion [Nolar]
BUGFIX: Max torrent file size was limited to 1MB - limit removed [Parg]
BUGFIX: Fix for several exceptions thrown during socket reads/writes [Nolar]
BUGFIX: Fix for exception thrown when peer sends an invalid bitfield [Nolar]
BUGFIX: AZ was reporting cumulative upload/download stats to tracker - should be per session [Parg]
BUGFIX: Fix for handling single data files larger than 2GB [Nolar]
BUGFIX: Corrected socket writing [Gudy]
BUGFIX: Weren't sending "complete" event to tracker on download->seeding transition [Parg]